## Adobe Photoshop

#### Q1. How can you open a file selected in Lightroom CC for retouching in Photoshop CC?
- [ ] Double-click the file
- [x] [Choose File > Edit in Photoshop](https://helpx.adobe.com/lightroom-cc/how-to/lightroom-photoshop-edit-photos.html#choose_a_photo_from_lightroom)
- [ ] Choose File > Save to Photoshop
- [ ] Press Cmd/Ctrl+E

#### Q2. How can you undo one or more changes just made to an image?
- [ ] Use the keyboard shortcut Cmd/Ctrl+Z
- [x] [Click a state in the history panel](https://helpx.adobe.com/uk/photoshop/using/undo-history.html#using_the_history_panel)
- [ ] Choose File > Undo
- [ ] Press Cmd/Ctrl+U

#### Q3. How can you select a specific layer? (find all that apply)
- [ ] Click the eye icon in the layers panel
- [x] [Use the Move tool with auto-select enabled](https://helpx.adobe.com/uk/photoshop/using/selecting-grouping-linking-layers.html#select_layers_in_the_document_window)
- [ ] Right-click the image and select layer
- [ ] Press Cmd/Ctrl and click the layer

#### Q4. How can you avoid having transparent edges along the edge of a panoramic photo while retaining the largest image size?
![How can you avoid having transparent edges along the edge of a panoramic photo while retaining the largest image size?](<image/Screenshot%20(441).png?raw=true>)
- [ ] Choose the Cylindrical method
- [ ] Choose the Perspective method.
- [ ] Adjust the Boundary Warp slider.
- [x] [Select Auto Crop.](https://helpx.adobe.com/uk/lightroom-classic/help/panorama.html)

#### Q5. How do you crop a document without permanently discarding pixels along the edge?
- [ ] Clear the Delete Cropped Pixels box.
- [ ] Select the Delete Cropped Pixels box.
- [x] Use the Smart Crop tool.
- [ ] Hold the Alt (Windows) or Option (Mac) key.

#### Q6. What feature should you use to simulate the in-camera development recipes applied by manufacturers with your own raw files?
- [ ] presets
- [x] Camera Matching profiles
- [ ] calibration
- [ ] snapshots

#### Q7. When working in an RGB document, which option is NOT a method for the Select Color Range command?
- [ ] Sampled Colors
- [ ] Skin Tones
- [x] Key (Blacks)
- [ ] Out of Gamut

#### Q8. How do you access the Auto Color Correction Options dialog box?
- [ ] Select Image > Auto Tone.
- [x] Select Image > Auto Color.
- [ ] Alt-click (Option-click) the Auto button in the Properties panel when you have a Levels or Curves adjustment layer targeted in the Layers panel.
- [ ] Hold down the Alt (Option) key and select Image > Auto Color.

#### Q9. Which options are available when using the Free Transform command on a Smart Object?

    A. Content-Aware Scale
    B. Scale
    C. Warp
    D. Distort
    E. Perspective Warp

- [ ] C,D
- [ ] D,E
- [x] [B,C ](https://helpx.adobe.com/photoshop/using/free-transformations-images-shapes-paths.html#:~:text=The%20Free%20Transform%20command%20lets,to%20switch%20between%20transformation%20types.)
- [ ] C,E

#### Q10. What is considered the minimum DPI for photographic-quality inkjet printing?
- [x] 300
- [ ] 100
- [ ] 1,000
- [ ] 72

#### Q11. Which scanner type is capable of producing the highest resolution scans?
- [x] flatbed scanner
- [ ] slide scanner
- [ ] all-in-one unit
- [x] drum scanner

#### Q12. Which format does NOT support an alpha channel?
- [ ] PSD
- [x] PNG
- [ ] TIFF
- [ ] BMP

#### Q13. What is the best way to save multiple images into a single PDF?
- [ ] Save each PDF separately first and then combine them.
- [ ] Check to see if you have Acrobat Professional installed.
- [x] Use the PDF Presentation command.
- [ ] Click File > Export > Export Layers to Files.

#### Q14. What option cannot be adjusted with the Print command directly in the Print window?
- [ ] size of the image
- [ ] position on the page.
- [x] paper quality.
- [ ] color management policies

#### Q15. Which statement best describes the Quick Mask feature?
- [ ] It allows you to use the Pen tool to edit a selection
- [x] It allows you to use the Brush tool to create or refine a selection
- [ ] It allows you to duplicate a mask quickly.
- [ ] It allows you to convert a vector mask to a layer mask.

#### Q16. What Photoshop feature was used to convert this image to black and white?
![What Photoshop feature was used to convert this image to black and white?](<image/Screenshot%20(444).png?raw=true>)
- [ ] Black and White adjustment layer
- [ ] Posterize
- [x] Threshold
- [ ] Image > Mode > Grayscale

#### Q17. In the image shown, why is Sharpen Edges grayed out?
![In the image shown, why is Sharpen Edges grayed out?](<image/Screenshot%20(440).png?raw=true>)
- [ ] The filter doesn't work on a 16-bit image.
- [ ] The filer is not correctly installed.
- [ ] The filter doesn't work on a 32-bit image.
- [x] The filter requires a selection to be made first.

#### Q18. In the image shown, which Camera Raw feature was used to restrict the graduated filter to avoid the statue?
![In the image shown, which Camera Raw feature was used to restrict the graduated filter to avoid the statue?](<image/Screenshot%20(443).png?raw=true>)
- [x] Adjustment Brush
- [ ] Depth Range Mask
- [ ] Luminance Range Mask
- [ ] Color Range Mask

#### Q19. What can you use to save a common crop size?
- [ ] tool sets
- [ ] preferences
- [ ] modifier keys
- [x] tool presets

#### Q20. Which Camera Raw Transform method is being used in the example shown?
![Which Camera Raw Transform method is being used in the example shown?](<image/Screenshot%20(442).png?raw=true>)
- [x] Guided
- [ ] Vertical
- [ ] Level
- [ ] Full

#### Q21. To reduce the file size of a PDF, what should you do?
- [ ] Upsample large images
- [ ] Convert 8-bit images to 16-bit
- [x] Apply compression to the document
- [ ] all of these answers

#### Q22. Which image adjustment is null available as an adjustment layer?
- [ ] Levels
- [x] Shadows/Highlights
- [ ] Curves
- [ ] Hue/Saturation

#### Q23. With default Essentials settings, where would you find the Red Eye tool?
- [ ] grouped with the Eyedropped tool
- [ ] Image > Mode > Red Eye
- [ ] Edit > Red Eye
- [x] grouped with the Spot Healing Brush tool

#### Q24. Which option was <em>not</em> selected in the Magic Wand tool to create a selection like the one shown below?
![Which option was <em>not</em> selected in the Magic Wand tool to create a selection like the one shown below?](image/Screenshot.question24.png?raw=true)
- [x] Contiguous
- [ ] Anti-alias
- [ ] Auto-Enhance
- [ ] Sample All Layers

#### Q25. Where should you click to open a dialog box in which you can then choose to open a raw file as a Smart Object?
![Where should you click to open a dialog box in which you can then choose to open a raw file as a Smart Object?](image/Screenshot.question25.png?raw=true)
- [ ] A
- [ ] B
- [x] C
- [ ] D

#### Q26. Which option would you use to clone while respecting perspective planes?
- [ ] Patch
- [x] Vanishing Point
- [ ] Clone Stamp
- [ ] Healing Brush

#### Q27. In order to run a filter on an entire video file, what must you do first?
- [ ] Convert the video file to an image sequence.
- [x] Convert the video file to a Smart Object.
- [ ] Actually, you cannot use filters on video files.
- [ ] Convert the video file to an animated gif.

#### Q28. Which option would you use to clone while respecting perspective planes?
- [ ] Patch
- [x] Vanishing Point
- [ ] Clone Stamp
- [ ] Healing Brush

#### Q29. Which file format does <em>not</em> support layers?
- [ ] Photoshop EPS
- [ ] Photoshop PDF
- [x] Large Document Format
- [ ] Photoshop PSD

#### Q30. Of these formats, which supports 16-bit images?
- [ ] JPEG
- [ ] GIF
- [x] PNG
- [ ] Photoshop EPS

#### Q31: What does the small black triangle in the lower-right corner of a tool indicate?
- [ ] that the tool is currently deselected
- [ ] tool options
- [ ] that the tool is currently selected
- [x] grouped or hidden tools

#### Q32: Which command makes it easier to adjust selected areas of color in two images in order to make them similar?
- [ ] Match Color
- [ ] Replace Color
- [x] Hue/Saturation
- [ ] Levels

#### Q33: If you scan a film or slide negative, which command turns it into a positive?
- [ ] Reverse
- [ ] Threshold
- [x] Invert
- [ ] Inverse

#### Q34: A filter recipe can be saved as an action and set to your desktop for drag-and-drop usage by converting the filter recipe into a **\_**.
- [x] droplet
- [ ] batch
- [ ] scriptlet
- [ ] image process

#### Q35: Which tool is not found in the Select and Mask taskspace?
- [ ] Refine Edge
- [ ] Quick Select
- [x] [Magic Wand](https://helpx.adobe.com/photoshop/using/select-mask.html#tools)
- [ ] Lasso

#### Q36: To use blending modes with a filter, choose the **\_** command.
- [ ] Mix
- [ ] Fade
- [ ] Smooth
- [x] Blend

#### Prove a video link of my assignment done [passed >70%](https://www.youtube.com/watch?v=3TLGPOWE5SA)
