## Agile Methodologies

#### Q1. Teams may encounter the need for "technical" user stories. Who decides the priority of these?
- [ ] the Product Owner with help from Operations
- [ ] the Tech Lead with help from the Product Owner
- [x] the Product Owner with help from the Tech Lead
- [ ] the Tech Lead with help from Operations

#### Q2. What is the Scrum Master's role during the daily stand-up?
- [ ] Congratulate the team on their great work.
- [x] Stand outside the circle of developers and listen for impediments.
- [ ] The Scrum Master should not attend—this meeting is for developers only.
- [ ] Ask each developer what they did since the last daily standup.

#### Q3. Which factor should not be considered during Sprint Planning?
- [ ] the team's velocity
- [x] the number of stories in the product backlog
- [ ] the stories that are ready
- [ ] the team's capacity

#### Q4. A team member has been showing signs of great personal distress: crying at work, snapping at colleagues, having heated phone conversations. As Team Facilitator, what should you do?
- [ ] Give the team member space and time to deal with their personal issues.
- [ ] Tell the others on the team that their teammate needs some emotional support.
- [x] Notify the team member's manager of your observations and ask the manager for help.
- [ ] Ask the team member if they would like to talk about what might be going on with them personally.

#### Q5. Which statement describes the flow of work in the Scaled Agile Framework?
- [ ] It is a "push" system.
- [ ] It is "push" at the top and "pull" at the bottom.
- [ ] It is a "pull" system.
- [x] It is neither "push" nor "pull."

#### Q6. What is the Product Owner's role in deciding the priority of work in the sprint backlog?
- [ ] None—the Scrum Master should prioritize the work in the sprint backlog.
- [ ] The PO should prioritize the items in the sprint backlog.
- [ ] The developers prioritize work unless they cannot complete it, in which case the PO should prioritize the remaining work.
- [x] None—the developers should prioritize the work in the sprint backlog.

#### Q7. The Scaled Agile Framework advocates that, if you measure only one thing, what should you measure?
- [ ] quality
- [ ] predictability of delivery
- [x] cost of delay
- [ ] return on investment

#### Q8. Why should you apply Weighted Shortest Job First?
- [ ] to maximize the return on investment
- [x] to determine the economic sequencing of the backlog
- [ ] to visualize queue length
- [ ] to fulfill a commitment to quality

Weighted Shortest Job First (WSJF) is a prioritization model used to sequence jobs (eg., Features, Capabilities, and Epics) to produce the maximum economic benefit. In a flow-based system, priorities are updated continuously to provide the best economic outcomes. Job sequencing, rather than individual job return on investment, produces the best result. To that end, WSJF is used to prioritize backlogs by calculating the relative CoD and job size (a proxy for the duration). [(Source)](https://www.scaledagileframework.com/wsjf/)


#### Q9. You have classified the features in your backlog according to risk and value. Which features should the development team work on first?
- [ ] low-value and high-risk
- [x] high-value and high-risk
- [ ] high-value and low-risk
- [ ] low-value and low-risk

It is suggested that high business value, high-risk items are worked on first. While that may seem counterintuitive, the earlier this work is done, the sooner the team will move to mitigate the issues and unknowns—leading to a higher quality product. If there's a failure, it will occur early and relatively inexpensively. [(Source)](https://agilescrumguide.com/blog/files/tag-product-backlog---business-value-and-risk.html)

#### Q10. In the Scaled Agile Framework, what is the role of Enablers?
- [x] They help extend the Architectural Runway.
- [ ] They connect vision to mission so the organization can be successful.
- [ ] They support team building.
- [ ] They remove the impediments to quality.

#### Q11. Which outcome is not expected of a Sprint Review?
- [ ] The team demonstrates its completed work.
- [x] The team reflects on how to improve its performance.
- [ ] Items in the backlog may be reprioritized.
- [ ] Stakeholders give feedback about the work completed.

#### Q12. What is not a technique used for splitting user stories?
- [ ] split by line-of-business
- [x] split compound user stories
- [ ] split by alternative paths
- [ ] split by interface

#### Q13. Who decides what the team will work on?
- [ ] the Scrum Master
- [x] a self-organizing team
- [ ] the Product Owner
- [ ] the Product Manager

#### Q14. Which choice is not a Scrum value?
- [ ] focus
- [x] integrity
- [ ] courage
- [ ] commitment

#### Q15. What should happen if the Product Owner does not accept a story by the end of the iteration?
- [ ] The team does not get credit for the story's points in its velocity calculation.
- [ ] The story should be sliced to reflect the work completed.
- [ ] The acceptance criteria should be adjusted to reflect the work completed.
- [x] The story should be shown to stakeholders for their feedback.

#### Q16. Which statement is not true about the product backlog?
- [x] It is a list of work items that are behind schedule.
- [ ] The items are maintained in priority order.
- [ ] Anyone on the team can propose an item for it.
- [ ] It includes all of the work to be done.

#### Q17. A project has some major risks that the team wants to mitigate. What is the best way to monitor how well this effort is going?
- [ ] risk-based spike
- [ ] risk-adjusted backlog
- [ ] risk velocity chart
- [x] risk burndown graph

#### Q18. The VP of engineering wants to start a Team Member of the Sprint Award to recognize a top performer in each group. What would you advise the VP?
- [ ] This is not a good idea unless there has been recent employee feedback that people feel underappreciated.
- [ ] It is a good idea as long as a different person is recognized in each sprint.
- [ ] It is a good idea because awards can motivate people to do their best.
- [x] This is not a good idea because it can destroy the team unity that is essential to achieving high performance.

#### Q19. What is a difference between a team's task board and a Kanban?
- [ ] A Kanban has an explicit rule to limit WIP.
- [ ] A Kanban shows the backlog of work.
- [ ] A Kanban does not use a Definition of Done.
- [x] A Kanban shows the status of the work items.

#### Q20. The team complains that "things have been falling through the cracks lately." What should you do?
- [ ] Ask the team's manager to make role assignments so the team can catch up.
- [x] Conduct a workshop to identify all of the things that need to be done and see who can help with each.
- [ ] Refer to the team's RACI (Responsible, Accountable, Consulted, Informed) assignments.
- [ ] Meet with the Tech Lead and Product Owner to try to identify what can be done.

#### Q21. In Large-Scale Scrum, what is the recommended ratio of Scrum Masters to teams?
- [ ] One Scrum Master can support up to five teams.
- [ ] Large teams should have two Scrum Masters.
- [ ] There should be one Scrum Master per team.
- [x] One Scrum Master can support one to three teams.

#### Q22. In the Cynefin framework, where are "best practices" most appropriate?
- [ ] in the Complex regime
- [ ] in the Complicated regime
- [ ] in the Chaotic regime
- [x] in the Obvious regime

#### Q23. A manager informs you that a developer from another team is between assignments, and she wants to place the developer on your team for a few sprints. What should you do?
- [x] Explain to the manager that this will be disruptive to the team and ask that another assignment be found.
- [ ] Explain the situation to the team and ask them to go with the flow.
- [ ] Explain the situation to your manager and ask them to resolve it.
- [ ] When the temporary developer shows up, assign them to write documentation.

#### Q24. The Product Owner complains to you that the team is not working hard enough and they need to increase their velocity by at least 50%. Which action should you not take?
- [x] Share the feedback from the PO and challenge the team to increase their velocity.
- [ ] Ask the PO to explain the business context to the team.
- [ ] Explain the impact of technical debt to the PO and the benefits of devoting some capacity to reducing it.
- [ ] Hold a Value Stream Mapping workshop to identify and reduce waste.

#### Q25. What is the name of the practice in which a cross-functional team collaborates intensively to develop a new product idea?
- [x] Hackathon
- [ ] Scrum at Scale
- [ ] Innovation and Planning
- [ ] Magnum Focus

#### Q26. The team's manager wants to attend the Sprint Retrospective. What should you do?
- [ ] Agree to the manager's request and notify the team.
- [ ] Propose that the manager attend only every other retrospective.
- [x] Propose a different forum for the manager to meet with the team.
- [ ] Ask the team if it is okay with them that the manager attend.

#### Q27. Who is responsible for a Scrum team's performance?
- [x] the team
- [ ] the Scrum Master
- [ ] the Product Owner
- [ ] the Engineering Manager

#### Q28. Which statement concerning small, frequent releases of software is true?
- [ ] The chance for rollback is high.
- [x] It typically requires a high degree of automation.
- [ ] The administrative costs are high.
- [ ] Backward compatibility may be jeopardized.

#### Q29. What is the activity of clarifying and expanding user stories called?
- [ ] story point estimating
- [ ] Definition of Done
- [ ] user story expansion
- [x] backlog refinement

#### Q30. Which strategy is preferred for development teams?
- [ ] Optimize for most work done.
- [x] Maximize output and maximize outcome.
- [ ] Maximize outcome while minimizing output.
- [ ] Optimize for resource utilization.

#### Q31. Which statement is true about the actor in a user story?
- [ ] The actor does not have to be a specified role in the solution.
- [ ] There must be multiple personas for each actor.
- [x] The actor can be the system itself.
- [ ] The system cannot be the actor.

#### Q32. Which statement is true about Agile?
- [ ] Agile requires a high degree of up-front planning.
- [ ] Once the requirements are agreed to, the team can complete work.
- [x] Agile requires a high degree of discipline.
- [ ] Agile works best when there is no contract.

#### Q33. Which statement about burndown and burnup charts is not true?
- [ ] Burndown charts show the work remaining to be done.
- [ ] Burnup charts show the work completed.
- [x] Burndown charts are more useful than burnup charts.
- [ ] Agile project management tools can produce these automatically.

#### Q34. What is the name for the practice of going to see a process in use at the point of value delivery?
- [ ] Six Sigma
- [x] Gemba walk
- [ ] Total Quality Management
- [ ] Kaizen

#### Q35. When the team needs to make a decision, what is the best course of action?
- [x] Try to achieve concensus.
- [ ] Take a vote and the majority rules.
- [ ] Identify the person who is most knowledgeable and ask them to decide.
- [ ] Let the most senior member of the team decide.

#### Q36. Which action is something the Team Facillitator should NOT do?
- [ ] Embrace servant leadership.
- [x] Estimate story points.
- [ ] Celebrate successes.
- [ ] Remove impediments

#### Q37. A team needs to do research, design, prototyping. What is this type of story called?
- [x] Exploratory spike
- [ ] Backlog refinement
- [ ] Functional decomposition
- [ ] R&D

#### Q38. Which statement about technical debt is true?
- [ ] Technical debt is another name for bugs
- [ ] It is at the Product Owner's description to allocate effort to reduce technical debt.
- [x] Adding technical debt should be avoided at all costs.
- [ ] Technical debt is what the Product Owner owes to the developers if they work a lot of overtime to complete the sprint.

#### Q39. Which statement about estimating is not true?
- [ ] Absolute estimating is more reliable than relative estimating.
- [ ] Relative estimating is more reliable than absolute estimating.
- [x] In estimating, accuracy is more important than precision.
- [ ] In estimating, the effort is more important than the time required.

#### Q40. Which ceremony should the Product Owner not attend?
- [ ] daily stand-ups
- [ ] Sprint Retrospectives
- [ ] story point estimating
- [x] code reviews

#### Q41. Which task is not the Product Owners responsibility?
- [ ] estimating story points
- [ ] refining acceptance criteria
- [x] giving feedback to developers about the user stories
- [ ] demonstrating the work to stakeholders

#### Q42. Which choice is `_not_` considered during Sprint Planning?
- [x] stories that meet the Definition of Done
- [ ] team velocity
- [ ] stories that meet the Definition of Ready
- [ ] team capacity

#### Q43. You have noticed a pattern that the most interesting stories on the Sprint Backlog get started right away, and the least interesting stories languish or don't get done. What should you do?
- [ ] Use a lottery system assign each story.
- [ ] Share your observation with the team and invite them to own and solve the problem.
- [ ] During story point estimation increase the points assigned to the least interesting stories so the team can boost their velocity.
- [x] Ask the Tech Lead to assign every story to a developer so they all get done efficiently and with accountability.

#### Q44. What Agile practice best supports this principle: "At regular intervals, the team reflects on how to become more effective, then tunes and adjusts its behavior accordingly"?
- [ ] Sprint Review
- [x] Sprint Retrospective
- [ ] daily stand-up
- [ ] Sprint Demo

#### Q45. On what are personas typically based?
- [ ] a sponsors or team members' personalities and traits
- [ ] what the developers think is user friendly
- [x] real people, archetypal users, or composites of multiple users
- [ ] descriptions of the product's functionality and use

#### Q46. Which statement describes Shu Ha Ri?
- [ ] It is a library of coding patterns.
- [ ] It is a software testing strategy.
- [ ] It is a standard for interface design.
- [x] It is a model for skill development and mastery.

#### Q47. What does the Agile Manifesto indicate?
- [x] Responding to change is more valuable than following a plan.
- [ ] Documenting requirements up front is more valuable than at the end.
- [ ] Following the plan is essential for not going over budget.
- [ ] Contract negotiation should be used to settle disputes.

#### Q48. What is the main benefit of a working agreement?
- [ ] It specifies core working hours.
- [ ] It clarifies the reporting relationships on the team.
- [x] It defines the culture that the team aspires to achieve.
- [ ] It compiles everyone's information.

#### Q49. What is the name of the information radiator that has multiple columns used to visualize the flow of work?
- [ ] Work Flow Indicator
- [ ] Value Stream Map
- [ ] Story Map
- [x] Kanban Beard

#### Q50. Which is the best definition of story points?
- [x] They are a relative measure of the effort needed to complete a story.
- [ ] They a measure of development time only, test time is considered separately.
- [ ] They are a relative measure of the value of a story.
- [ ] They are a measure of time to complete a story.

#### Q51. What is a Scrum of Scrums?
- [x] It is technique for two or more teams working together coordinate their efforts.
- [ ] It is another name for the Scrum Master Community of Practice.
- [ ] It is an information radiator used to compare the velocity of several teams.
- [ ] It is the system demo for teams on the same release train.

#### Q52. What is the Product Owner's role regarding the product backlog?
- [ ] The PO must identify the intended users of the features on the backlog.
- [ ] The PO is responsible for estimating the size of the total.
- [x] The PO must identify the dependencies that impact the backlog.
- [ ] The PO decides what to include in the backlog and what to exclude.

#### Q53. Why should a team do refactoring?
- [ ] It assigns developers to other teams in order to eliminate personality conflicts.
- [ ] It improves the functionality of the product,
- [ ] It recalibrates the success criteria for the product in the marketplace.
- [x] It improves the design, which can lead improved development efficiency and maintainability.

#### Q54. Which choice is not a benefit generally associated with product demonstrations?
- [ ] Learn about new requirements.
- [ ] Learn feature suitability.
- [ ] Learn about feature usability.
- [x] Learn about feature estimates.

#### Q55. What is an information radiator?
- [ ] a list of KPIs for the team
- [ ] a list of overdue action items
- [x] the task board
- [ ] a highly visible display of key performance data

#### Q56. According to the Agile Manifesto, your highest priority is to `**\_\_**`.
- [ ] minimize change requests
- [x] satisfy the customer
- [ ] get the job done on time
- [ ] achieve the desired ROI

#### Q57. Product development organizations sometimes use descriptions of archetypal users and their values so that developers can design the system to meet their needs and wants. What are these descriptions called?
- [ ] actors
- [ ] roles
- [ ] agents
- [x] personas

#### Q58. The Product Owner is focused on testing a new system concept in the marketplace as quickly and inexpensively as possible. What is this first-generation product called?
- [ ] preproduction version
- [ ] focus group demonstrator
- [ ] Generation 1 product
- [x] minimum viable product

#### Q59. To whom should the Product Owner report?
- [ ] the Quality Manager
- [x] the Product Manager
- [ ] the Scrum Master
- [ ] the Engineering Manager

#### Q60. What happens in Splint 0?
- [ ] The team delivers no story points in that sprint.
- [ ] The team does regression testing prior to release to production.
- [x] The team prepares to work on the product backlog.
- [ ] This is the time to inspect and adapt.

#### Q61. What does the Definition of Done mean?
- [ ] The story meets the INVEST criteria.
- [ ] The team has completed all of the work in its Sprint.
- [ ] The story has been handed off to the DevOps team.
- [x] The team has agreed on the criteria for story completion.

#### Q62. Which element is most important when describing your product?
- [ ] its cost
- [ ] its licensing terms and conditions
- [x] its benefits
- [ ] its features

#### Q63. Which choice best describes the Team Facilitator?
- [ ] a meeting scheduler
- [ ] a record keeper
- [ ] a project manager
- [x] an Agile coach

#### Q64. What is the name of the technique that divides a story into smaller pieces?
- [ ] mitosis
- [ ] story slicing
- [x] disaggregation
- [ ] Divide and Conquer

#### Q65. A team member comes to you with a complaint about another team member. What should you do?
- [ ] Bring the complaint to the other person and try to resolve the issue.
- [ ] Ask them to talk to the other person and try to work it.
- [ ] Notify HR of the problem and ask them to handle it.
- [x] Invite both people a meeting and try mediate the conflict.

#### Q66. What is the forming-storming-norming, performing model of team development known as?
- [x] the Tuckman model
- [ ] the Standard Team model
- [ ] Moore's Team Framework
- [ ] the Siebert model

#### Q67. What is the name of the ceremony in which you inspect the work completed during the sprint?
- [ ] Sprint Retrospective
- [x] Sprint Review //Answer?
- [ ] Next-Sprint Planning
- [ ] Velocity Confirmation

#### Q68. Which choice best describes an Agile Release Train (ART)?
- [x] continuous delivery
- [ ] comprised of the teams within a program
- [ ] DevOps Center of Excellence
- [ ] Scrum of Scrums

#### Q69. As an Agile coach, what should be your attitude toward your team members individual goals and motivations?
- [ ] Understand them—try align personal motivations with the team's progress toward the project goals.
- [ ] Nurture them-goals are the reason why people want to be at work.
- [ ] Disregard them—personal views have no bearing on reaching the project goals.
- [x] Leverage them—use personal goals encourage team members raise their performance levels.

#### Q70. Which phrase best describes an Agile team?
- [ ] self-directed
- [ ] self-managed
- [ ] self-sustaining
- [x] self-organizing

#### Q71. Which technique does not help prioritize the backlog?
- [ ] MoSCow
- [ ] Kano
- [ ] WSJF
- [x] Kaizen

#### Q72. What does the Definition of Ready mean?
- [ ] The story has been tested end is ready for release to production.
- [x] The story is ready to be brought into a sprint. //Answer?
- [ ] The stakeholders are ready to discuss their requirements for story.
- [ ] The team has completed sprint 0 and is ready to work.

#### Q73. Which is NOT a principle of the Scaled Agile Framework?
- [ ] Centralize decision-making
- [ ] Apply systems thinking
- [ ] Take an economic view
- [x] Unlock the intrinsic motivation of knowledge workers

#### Q74. Which statement concerning small, frequent releases of software is true?
- [ ] The chance for rollback is high
- [x] It typically requires a high degree of automation
- [ ] Backward compatibility may be jeopardized
- [ ] The administrative costs are high

#### Q75. What is the definition of capacity?
- [ ] It is an inventory of the team's knowledge and skills that is used to plan the work that they do.
- [ ] It is the number of teams that a Team Facilitator can support concurrently.
- [ ] It is an adjustment to velocity, used in Spring Planning, to account for reduced availability of team members during the upcoming sprint.
- [x] It is the maximum number of stories that will be allowed in a sprint.

#### Q76. Which action is something the Team Facilitator should not do?
- [ ] Celebrate Success.
- [ ] Embrace servant leadership.
- [ ] Remove impediments
- [x] Estimate story points.
