## Google Analytics

#### Q1. In the following URL, what channel grouping is traffic assigned to?
`example.com/?utm_source=google&utm_medium=cpc&utm_campaign=315`
- [ ] Display
- [ ] Google
- [ ] Organic Search
- [x] Paid Search

#### Q2. If you want to evaluate if direct traffic delivered more traffic than organic search in August 2019, which report do you look at?
- [ ] Audience > Behavior > Engagement
- [ ] Realtime > Traffic Sources
- [x] Acquisition > All Traffic > Channels
- [ ] Acquisition > All Traffic > Referrals

#### Q3. What is the relationship between an event and an event goal?
- [ ] Nothing, an event is another name for event goal.
- [ ] An event is captured per user; an event goal is captured per session.
- [ ] An event goal must be created in order to track events.
- [x] An event is a user interaction; an event goal is triggered by a selected event.

#### Q4. A user downloads a white paper with event tracking once in a single session. Another user downloads the same white paper three times in a single session. How many unique events are counted?
- [x] one
- [ ] three
- [ ] two
- [ ] four

#### Q5. What are the icons highlighted below used for?
![Google Analytics Icons](https://i.imgur.com/LZzFesL.png)
- [x] to change the way the data table is displayed
- [ ] to adjust the date range
- [ ] to assign secondary dimensions
- [ ] to compare data to previous periods

#### Q6. Which report would help you measure the value of your social media efforts?
- [ ] Campaigns > Cost Analysis
- [x] Social > Conversions
- [ ] Goals > Reverse Goal Path
- [ ] Goals > Smart Goals

#### Q7. What is an example of a metric?
- [ ] City
- [ ] Source/Medium
- [ ] Browser
- [x] Pageviews

#### Q8. You want to verify that Google Analytics is working immediately after installation. Which report do you review?
- [ ] Audience > Active Users
- [ ] Acquisition > Overview
- [x] Realtime > Overview
- [ ] Behavior > Behavior Flow

#### Q9. Which Chrome extension, developed by Google, would be valuable for identifying deployment issues with Google Analytics?
- [ ] Click & Test
- [ ] Google Keep
- [ ] Express UTM
- [x] Google Analytics Debugger

#### Q10. You want to track example.com and other example.com using a single property. What must be set up?
- [x] cross domain tracking 
- [ ] Google Tag Manager
- [ ] Include and Exclude filters
- [ ] custom dimensions

#### Q11. If you posted a link offering 50% off a hat, but the link sent people to a page of sweaters, what impact would you most likely see?
- [ ] a high page score
- [ ] a low bounce rate
- [x] a high bounce rate
- [ ] a low page score

#### Q12. To email a notification whenever a goal is completed, what do you configure?
- [ ] scheduled emails
- [x] custom alerts
- [ ] shared reports
- [ ] shared assets

#### Q13. What must be configured in order for Google Analytics to capture data?
- [ ] UTM parameters
- [ ] Google Tag Manager
- [ ] User- [ ] ID feature
- [x] Analytics tracking code

#### Q14. What allows you to specify the steps your traffic is expected to take to reach your goal?
- [ ] destination
- [x] funnel
- [ ] visualization
- [ ] value

#### Q15. If you wanted to evaluate how your site performs relative to other sites in your industry vertical, what reports do you use?
- [x] Benchmarking
- [ ] Cohort Analysis
- [ ] Network Referrals
- [ ] Publisher Referrers

### Q16. What is the hierarchy of a Google Analytics account?
- [ ] Account > Property > Organization > Views
- [x] Organization > Account > Property > Views
[proof link](https://support.google.com/analytics/answer/1009618?hl=en)
- [ ] Organization > Property > Account > Views
- [ ] Account > Organization > Property > Views

### Q17. What feature do you configure if you want to track transactions, order values, shopping cart behavior, and product performance?
- [ ] campaigns
- [ ] revenue
- [ ] ecommerce
- [ ] ROAS (Return On Ad Spend)

### Q18. What is an example of data you cannot track in Google Analytics?
- [ ] page speed score
- [ ] return on advertising spend
- [ ] precise user latitude/longitude data
- [ ] time on site

### Q19. If you create a new user at the property level, what does the user inherit access to?
- [ ] all the views of that property
- [ ] all the accounts in the organization
- [ ] Nothing—each permission must be set manually.
- [ ] all the properties in the account

### Q20. Of the following segments, which represents the highest value audience?
- [ ] users who converted
- [ ] sessions with a >80% bounce rate
- [ ] all multisession users
- [ ] sessions with 0 goal completions

### Q21. If you wanted to determine if a particular browser was resulting in a high bounce rate, what report could you look at?
- [ ] Technology > Browser & OS
- [ ] Site Speed > Page Timings
- [ ] Mobile > Devices
- [ ] Behavior > Engagement

### Q22. You offer a downloadable music file called Sample Tone on your website. What is the best way to configure the components to track this event?
- [ ] Hit: Download // Event: Sample Tone // Content: Music
- [ ] Category: Music // Action: Download // Label: Sample Tone
- [ ] Category: Download // Event: Music // Label: Sample Tone
- [ ] Hit: Music // Event: Download //Content: Sample Tone

### Q23. You want to classify people who join your newsletter with a custom dimension for "Newsletter Subscribers." What is the appropriate scope to apply to this custom dimension?
- [ ] User
- [ ] Hit
- [ ] Product
- [ ] Session

### Q24. You are viewing a report with Source/Medium as the primary dimension, but also want to include landing page data. What do you do?
- [ ] Use a filter.
- [ ] Create a new view.
- [ ] This is not possible.
- [ ] Use a secondary dimension.

### Q25. If you are collecting campaign data, which report shows the results?
- [ ] Acquisition > Campaigns > All Campaigns
- [ ] Audience > Custom > Custom Variables
- [ ] Conversions > Goals > Overview
- [ ] Behavior > Events > Overview

### Q26. If you wanted to verify Google Analytics was working immediately after installation, which report would you review?
- [ ] Acquisition > Overview
- [ ] Realtime > Overview
- [ ] Behavior > Behavior Flow
- [ ] Audience > Active Users

### Q27. What does this represent inside of Google Analytics?
- [ ] segment
- [ ] report tab
- [ ] data header
- [ ] view

### Q28. In the following URL, what channel grouping is traffic assigned to? example.com/?utm_source=google&utm_medium=cpc&utm_campaign=315
- [ ] Organic Search
- [ ] Google
- [ ] Paid Search
- [ ] Display

### Q29. What is the relationship between an event and an event goal?
- [ ] An event goal must be created in order to track events.
- [ ] Nothing, an event is another name for event goal.
- [ ] An event is captured per user; an event goal is captured per session.
- [ ] An event is a user interaction; an event goal is triggered by a selected event.

### Q30. When configuring the global site tag, where in the HTML should it be placed?
- [ ] directly before the </head> tag
- [ ] directly after the <head> tag
- [ ] directly after the <body> tag
- [ ] directly before the </body> tag

### Q31. Refer to the two following URLs. How can you make this data more readable in Google Analytics by mapping the actual product names to the ID in the URL? .../shop/?ProductID=1234 .../shop/?ProductID=5678
- [ ] Configure calculated metrics.
- [ ] Use a custom import.
- [ ] This functionality is not possible.
- [ ] Create a search and replace filter.

### Q32. What is this report an example of?
- [ ] cohort analysis
- [ ] funnel visualization
- [ ] user flow
- [x] treemap

### Q33. You already have Google Analytics set up on your website, but decide to add Google Tag Manager. What do you do with the existing Analytics tag?
- [ ] Remove the tag.
- [ ] Move the tag to just before </head>.
- [ ] Keep the tag.
- [ ] Move the tag to just before </body>.

### Q34. How do you review the revenue and conversion rate between your traffic sources?
- [ ] Create two segments, one for revenue and one for conversion rate, and then review Acquisition > All Traffic.
- [ ] View Ecommerce > Overview and toggle Traffic Sources in the Explorer tab.
- [ ] Create two segments, one for revenue and one for conversion rate, and then review Conversions > Ecommerce.
- [ ] Go to All Traffic > Source Medium and set eCommerce in the Conversions menu.

### Q35. Which calculated metric would return average events per user?
- [ ] {{Total Events}} / {{Users}} Type: Float
- [ ] {{Goals}} / {{Users}} Type: Percentage
- [ ] {{Goals}} / {{Users}} Type: Float
- [ ] {{Total Events}} / {{Users}} Type: Percentage

### Q36. What report helps you understand how many days it takes from the time a user first visits to the time the user converts?
- [ ] Assisted Conversions
- [ ] Time Lag
- [ ] Path Length
- [ ] Shopping Behavior

### Q37. What is a best practice after launching a major change to your home page?
- [ ] Create a new filter.
- [ ] Create an annotation.
- [ ] Create a new view.
- [ ] Create a new property.

### Q38. You want to enable a destination goal for a URL that appends query string parameters with each submission—for example, /thanks?uid=123. Which match types would work?
- [ ] equals to /thanks
- [ ] begins with /thanks
- [ ] equals to /thanks?uid=
- [ ] regular expression /thanks[a z]

### Q39. You notice a sudden and unexplained change in traffic. Where do you look to see if someone added a filter?
- [ ] Admin > Views > View Settings
- [ ] Admin > Account > Change History
- [ ] Admin > Views > Annotations
- [ ] Admin > Account > User Management

### Q40. Your website has a logged in experience for users. What do you implement to track individual engagement across multiple sessions and multiple devices?
- [ ] Client- [ ] ID
- [ ] User- [ ] ID
- [ ] cross- [ ] domain tracking
- [ ] session unification

### Q41. What are these examples of?
- [ ] annotations
- [ ] affinity categories
- [ ] custom audiences
- [ ] channels

### Q42. If you want to evaluate if direct traffic delivered more traffic than organic search in August 2019, which report do you look at?
- [ ] Audience > Behavior > Engagement
- [ ] Realtime > Traffic Sources
- [ ] Acquisition > All Traffic > Referrals
- [ ] Acquisition > All Traffic > Channels

### Q43. Where can you check the status of your tracking code?
- [ ] Admin > Tracking Info > Tracking Code
- [ ] Customization > Settings > Tracking Code
- [ ] Customization > Property > Tracking
- [ ] Admin > Property Settings

### Q44. What feature do you use to capture how many times a button was pressed?
- [ ] action tracking
- [ ] click handler
- [ ] event tracking
- [ ] goals

### Q45. Which step in this funnel had the largest percentage of exits?
- [ ] Billing and Shipping
- [ ] Cart
- [ ] There are no exits.
- [ ] Payment

### Q46. What can you use as the basis for remarketing within Google Ads?
- [ ] dynamics
- [ ] personas
- [ ] audiences
- [ ] tags

### Q47. If you want to exclude traffic to your website from people on your company network, what do you create?
- [ ] a filter to exclude traffic to the hostname
- [ ] a segment to exclude traffic to the hostname
- [ ] a segment to exclude traffic from IP addresses
- [ ] a filter to exclude traffic from IP addresses

### Q48. You are running Google Ads and want to automatically track ad performance within Google Analytics. What feature do you enable?
- [ ] auto tagging
- [ ] ad serving
- [ ] advertising features
- [ ] API link

### Q49. What is an example of a property in Google Analytics?
- [ ] account
- [ ] website
- [ ] graph
- [ ] custom report

### Q50. By default, if a URL is accessed in the browser once as /contact/ and once again as /CONTACT/, how does the data appear in Google Analytics?
- [ ] two pageviews for /contact/
- [ ] one pageview for /contact/ and one pageview for /CONTACT/
- [ ] An error will be present, as a filter must be created to support this use case.
- [ ] two pageviews for /CONTACT/

### Q51. What is the hierarchy between sessions, users, and hits?
- [ ] User > Session > Hit
- [ ] Session > Hit > User
- [ ] Session > User > Hit
- [ ] User > Hit > Session

### Q52. Which feature would allow you to navigate between multiple reports while comparing the data collected for visitors in Los Angeles to the data for visitors in London?
- [ ] segments
- [ ] filters
- [ ] views
- [ ] dimensions

### Q53. Where could you analyze the conversion paths users followed across various marketing channels?
- [ ] Conversions > Goals > Reverse Goal Path
- [ ] Conversions > Goals > Funnel Visualization
- [ ] Behavior > Behavior Flow
- [ ] Conversions > Multi- [ ] Channel Funnels

### Q54. What does Google Analytics add to the first party cookie to differentiate new from returning visitors?What does Google Analytics add to the first party cookie to differentiate new from returning visitors?
- [ ] an HTTP requestan HTTP request
- [ ] a randomly generated client IDa randomly generated client ID
- [ ] a 1x1 tracking pixela 1x1 tracking pixel
- [ ] a SessionStorage object

### Q55. It is September, and you want to evaluate the most popular page on your site for the month of August. What first steps would you take?
- [ ] 1. Set Date Range to Last 30 Days. 2. Visit Behavior > Site Content > All Pages.
- [ ] 1. Set Date Range to Last 30 Days. 2. Visit Behavior > Site Content > Content Drilldown.
- [ ] 1. Set Date Range to Last Month. 2. Visit Behavior > Site Content > Content Drilldown.
- [ ] 1. Set Date Range to Last Month. 2. Visit Behavior > Site Content > All Pages.

### Q56. This report is sorted by bounce rate in ascending order. How do you view these results in order of importance instead?
- [ ] Sort Type: Absolute Change
- [ ] Toggle Comparison View
- [ ] Sort Type: Weighted Sort
- [ ] Use Table Filter

### Q57. What channel receives attribution if no traffic source data is available?
- [ ] (Other)
- [ ] Direct
- [ ] Referral
- [ ] Organic Search

### Q58. Which is an example of a micro goal?
- [ ] signing up for an account after clicking an ad
- [ ] playing a video before signing up
- [ ] buying a product after reading an email
- [ ] filling out a contact form after reading a social post

### Q59. What parameter should you use if you were tracking different versions of an ad?
- [ ] utm_campaign
- [ ] utm_medium
- [ ] utm_term
- [ ] utm_content

### Q60. The tracking ID contains a string that follows this format: UA XXXXXX Y. What does the Y refer to?
- [x] the property number
- [ ] the account number
- [ ] the view number
- [ ] It is random.

### Q61.If a user fills in a contact form and provides an email address, which report would contain that information?
- [ ] Behavior > Events > Overview
- [ ] Acquisition > Social > Form Submissions
- [ ] Acquisition > Social > Users Flow
- [ ] No report contains this information.

### Q62.If you want to quickly see what days and times were most popular for visiting your site, what do you do?
- [ ] Go to Home > Users by time of day (Widget)
- [ ] Go to the report at Audience > Cohort Analysis and toggle By Day.
- [ ] Go to Behavior > Engagement and toggle Hourly.
- [ ] Create a pivot table by Hour on Site Content > All Pages.

### Q63. If your site does not attribute transactions to the original source, but instead shows all transactions attributed to your payment processor (for example Stripe, PayPal, or Square), how do you remedy this issue?
- [ ] Switch to Enhanced Ecommerce.
- [ ] Use a search and replace filter.
- [x] Create a referral exclusion.
- [ ] Add gtag.js to Paypal tags.

### Q64. What do you use to compare three dimensions?
- [ ] performance table
- [x] custom reports
- [ ] Explorer panel
- [ ] relational table

### Q65. Is it possible to measure how far someone scrolls on a page using Google Analytics? If so, how?
- [ ] yes, with a calculated metric
- [x] yes, by viewing in page analytics
- [ ] yes, with event tracking
- [ ] no, not possible
