﻿## Machine Learning

#### Q1. You are part of data science team that is working for a national fast-food chain. You create a simple report that shows trend: Customers who visit the store more often and buy smaller meals spend more than customers who visit less frequently and buy larger meals. What is the most likely diagram that your team created?

- [x] multiclass classification diagram
- [ ] linear regression and scatter plots
- [ ] pivot table
- [ ] K-means cluster diagram

#### Q2. You work for an organization that sells a spam filtering service to large companies. Your organization wants to transition its product to use machine learning. It currently a list Of 250,00 keywords. If a message contains more than few of these keywords, then it is identified as spam. What would be one advantage of transitioning to machine learning?

- [ ] The product would look for new patterns in spam messages.
- [ ] The product could go through the keyword list much more quickly.
- [ ] The product could have a much longer keyword list.
- [x] The product could find spam messages using far fewer keywords.

#### Q3. You work for a music streaming service and want to use supervised machine learning to classify music into different genres. Your service has collected thousands of songs in each genre, and you used this as your training data. Now you pull out a small random subset of all the songs in your service. What is this subset called?

- [ ] data cluster
- [ ] Supervised set
- [ ] big data
- [x] test data

#### Q4. In traditional computer programming, you input commands. What do you input with machine learning?

- [ ] patterns
- [ ] programs
- [ ] rules
- [x] data

#### Q5. Your company wants to predict whether existing automotive insurance customers are more likely to buy homeowners insurance. It created a model to better predict the best customers contact about homeowners insurance, and the model had a low variance but high bias. What does that say about the data model?

- [x] It was consistently wrong.
- [ ] It was inconsistently wrong.
- [ ] It was consistently right.
- [ ] It was equally right end wrong.

[Reference](https://medium.com/datadriveninvestor/bias-and-variance-in-machine-learning-51fdd38d1f86)

#### Q6. You want to identify global weather patterns that may have been affected by climate change. To do so, you want to use machine learning algorithms to find patterns that would otherwise be imperceptible to a human meteorologist. What is the place to start?

- [ ] Find labeled data of sunny days so that the machine will learn to identify bad weather.
- [x] Use unsupervised learning have the machine look for anomalies in a massive weather database.
- [ ] Create a training set of unusual patterns and ask the machine learning algorithms to classify them.
- [ ] Create a training set of normal weather and have the machine look for similar patterns.

#### Q7. You work in a data science team that wants to improve the accuracy of its K-nearest neighbor result by running on top of a naive Bayes result. What is this an example of?

- [ ] regression
- [ ] boosting
- [ ] bagging
- [x] stacking

#### Q8. `\_\_\_\_` looks at the relationship between predictors and your outcome.

- [x] Regression analysis
- [ ] K-means clustering
- [ ] Big data
- [ ] Unsupervised learning

#### Q9. What is an example of a commercial application for a machine learning system?

- [ ] a data entry system
- [ ] a data warehouse system
- [ ] a massive data repository
- [x] a product recommendation system

#### Q10. What does this image illustrate?

![Machine Learning Q10](images/machine-learning_Q10.jpg)

- [x] a decision tree
- [ ] reinforcement learning
- [ ] K-nearest neighbor
- [ ] a clear trendline

#### Q11. You work for a power company that owns hundreds of thousands of electric meters. These meters are connected to the internet and transmit energy usage data in real-time. Your supervisor asks you to direct project to use machine learning to analyze this usage data. Why are machine learning algorithms ideal in this scenario?

- [ ] The algorithms would help the meters access the internet.
- [ ] The algorithms will improve the wireless connectivity.
- [x] The algorithms would help your organization see patterns of the data.
- [ ] By using machine learning algorithms, you are creating an IoT device.

#### Q12. To predict a quantity value. use `\_\_\_\_`.

- [x] regression
- [ ] clustering
- [ ] classification
- [ ] dimensionality reduction

#### Q13. Why is naive Bayes called naive?

- [ ] It naively assumes that you will have no data.
- [ ] It does not even try to create accurate predictions.
- [x] It naively assumes that the predictors are independent from one another.
- [ ] It naively assumes that all the predictors depend on one another.

#### Q14. You work for an ice cream shop and created the chart below, which shows the relationship between the outside temperature and ice cream sales. What is the best description of this chart?

![Machine Learning Q14](images/machine-learning_Q14.jpg)

- [x] It is a linear regression chart.
- [ ] It is a supervised trendline chart.
- [ ] It is a decision tree.
- [ ] It is a clustering trend chart.

#### Q15. How is machine learning related to artificial intelligence?

- [ ] Artificial intelligence focuses on classification, while machine learning is about clustering data.
- [x] Machine learning is a type of artificial intelligence that relies on learning through data.
- [ ] Artificial intelligence is form of unsupervised machine learning.
- [ ] Machine learning and artificial intelligence are the same thing.

#### Q16. How do machine learning algorithms make more precise predictions?

- [ ] The algorithms are typically run more powerful servers.
- [x] The algorithms are better at seeing patterns in the data.
- [ ] Machine learning servers can host larger databases.
- [ ] The algorithms can run on unstructured data.

#### Q17. You work for an insurance company. Which machine learning project would add the most value for the company!

- [ ] Create an artificial neural network that would host the company directory.
- [x] Use machine learning to better predict risk.
- [ ] Create an algorithm that consolidates all of your Excel spreadsheets into one data lake.
- [ ] Use machine learning and big data to research salary requirements.

#### Q18. What is the missing information in this diagram?

![Machine Learning Q18](images/machine-learning_Q18.jpg)

- [ ] Training Set
- [ ] Unsupervised Data
- [x] Supervised Learning
- [ ] Binary Classification

#### Q19. What is one reason not to use the same data for both your training set and your testing set?

- [ ] You will almost certainly underfit the model.
- [ ] You will pick the wrong algorithm.
- [ ] You might not have enough data for both.
- [x] You will almost certainly overfit the model.

#### Q20. Your university wants to use machine learning algorithms to help sort through incoming student applications. An administrator asks if the admissions decisions might be biased against any particular group, such as women. What would be the best answer?

- [ ] Machine learning algorithms are based on math and statistics, and so by definition will be unbiased.
- [ ] There is no way to identify bias in the data.
- [ ] Machine learning algorithms are powerful enough to eliminate bias from the data.
- [x] All human-created data is biased, and data scientists need to account for that.

**Explanation**: While machine learning algorithms don't have bias, the data can have them.

#### Q21. What is stacking?

- [x] The predictions of one model become the inputs another.
- [ ] You use different versions of machine learning algorithms.
- [ ] You use several machine learning algorithms to boost your results.
- [ ] You stack your training set and testing set together.

#### Q22. You want to create a supervised machine learning system that identifies pictures of kittens on social media. To do this, you have collected more than 100,000 images of kittens. What is this collection of images called?

- [x] training data
- [ ] linear regression
- [ ] big data
- [ ] test data

#### Q23. You are working on a project that involves clustering together images of different dogs. You take image and identify it as your centroid image. What type machine learning algorithm are you using?

- [ ] centroid reinforcement
- [ ] K-nearest neighbor
- [ ] binary classification
- [x] K-means clustering

**Explanation**: The problem explicitly states "clustering".

#### Q24. Your company wants you to build an internal email text prediction model to speed up the time that employees spend writing emails. What should you do?

- [x] Include training email data from all employees.
- [ ] Include training email data from new employees.
- [ ] Include training email data from seasoned employees.
- [ ] Include training email data from employees who write the majority of internal emails.

#### Q25. Your organization allows people to create online professional profiles. A key feature is the ability to create clusters of people who are professionally connected to one another. What type of machine learning method is used to create these clusters?

- [x] unsupervised machine learning
- [ ] binary classification
- [ ] supervised machine learning
- [ ] reinforcement learning

#### Q26. What is this diagram a good example of?

![Machine Learning Q26](images/machine-learning_Q26.jpg)

- [ ] K-nearest neighbor
- [ ] a decision tree
- [ ] a linear regression
- [x] a K-means cluster

Note: thre are centres of clusters (C0, C1, C2).

#### Q27. Random forest is modified and improved version of which earlier technique?

- [ ] aggregated trees
- [ ] boosted trees
- [x] bagged trees
- [ ] stacked trees

#### Q28. Self-organizing maps are specialized neural network for which type of machine learning?

- [x] semi-supervised learning
- [ ] supervised learning
- [ ] reinforcement learning
- [ ] unsupervised learning

#### Q29. Which statement about K-means clustering is true?

- [x] In K-means clustering, the initial centroids are sometimes randomly selected.
- [ ] K-means clustering is often used in supervised machine learning.
- [ ] The number of clusters are always randomly selected.
- [ ] To be accurate, you want your centroids outside of the cluster.

#### Q30. You created machine learning system that interacts with its environment and responds to errors and rewards. What type of machine learning system is it?

- [ ] supervised learning
- [ ] semi-supervised learning
- [x] reinforcement learning
- [ ] unsupervised learning

#### Q31. Your data science team must build a binary classifier, and the number one criterion is the fastest possible scoring at deployment. It may even be deployed in real time. Which technique will produce a model that will likely be fastest for the deployment team use to new cases?

- [ ] random forest
- [x] logistic regression
- [ ] KNN
- [ ] deep neural network

#### Q32. Your data science team wants to use the K-nearest neighbor classification algorithm. Someone on your team wants w use a K of 25. What are the challenges of this approach?

- [ ] Higher K values will produce noisy data.
- [ ] Higher K values lower the bias but increase the variance.
- [ ] Higher K values need a larger training set.
- [x] Higher K values lower the variance but increase the bias.

#### Q33. Your machine learning system is attempting to describe a hidden structure from unlabeled data. How would you describe this machine learning method?

- [ ] supervised learning
- [x] unsupervised learning
- [ ] reinforcement learning
- [ ] semi-unsupervised learning

#### Q34. You work for a large credit card processing company that wants to create targeted promotions for its customers. The data science team created a machine learning system that groups together customers who made similar purchases, and divides those customers based on customer loyalty. How would you describe this machine learning approach?

- [x] It uses unsupervised learning to cluster together transactions and unsupervised learning to classify the customers.
- [ ] It uses only unsupervised machine learning.
- [ ] It uses supervised learning to create clusters and unsupervised learning for classification.
- [ ] It uses reinforcement learning to classify the customers.

#### Q35. You are using K-nearest neighbor and you have a K of 1. What are you likely to see when you train the model?

- [x] high variance and low bias
- [ ] low bias and low variance
- [ ] low variance and high bias
- [ ] high bias and high variance

#### Q36. Are data model bias and variance a challenge with unsupervised learning?

- [ ] No, data model bias and variance are only a challenge with reinforcement learning.
- [x] Yes, data model bias is a challenge when the machine creates clusters.
- [ ] Yes, data model variance trains the unsupervised machine learning algorithm.
- [ ] No, data model bias and variance involve supervised learning.

#### Q37. Which choice is best for binary classification?

- [ ] K-means
- [x] Logistic regression
- [ ] Linear regression
- [ ] Principal Component Analysis (PCA)

**Explanation:** Logistic regression is far better than linear regression at binary classification since it biases the result toward one extreme or the other. K-means clustering can be used for classification but is not as accurate in most scenarios.
[Source:](https://www.kaggle.com/minc33/k-means-clustering-vs-logistic-regression)

#### Q38. With traditional programming, the programmer typically inputs commands. With machine learning, the programmer inputs

- [ ] supervised learning
- [x] data
- [ ] unsupervised learning
- [ ] algorithms

**Explanation**: This one is pretty straight forward and a fundamental concept.
[Source:](https://towardsdatascience.com/machine-learning-for-beginners-d247a9420dab)

#### Q39. Why is it important for machine learning algorithms to have access to high-quality data?

- [ ] It will take too long for programmers to scrub poor data.
- [ ] If the data is high quality, the algorithms will be easier to develop.
- [ ] Low-quality data requires much more processing power than high-quality data.
- [x] If the data is low quality, you will get inaccurate results.

#### Q40. In K-nearest neighbor, the closer you are to neighbor, the more likely you are to

- [x] share common characteristics
- [ ] be part of the root node
- [ ] have a Euclidean connection
- [ ] be part of the same cluster

#### Q41. In the HBO show Silicon Valley, one of the characters creates a mobile application called Not Hot Dog. It works by having the user take a photograph of food with their mobile device. Then the app says whether the food is a hot dog. To create the app, the software developer uploaded hundreds of thousands of pictures of hot dogs. How would you describe this type of machine learning?

- [ ] Reinforcement machine learning
- [ ] unsupervised machine learning
- [x] supervised machine learning
- [ ] semi-supervised machine learning

#### Q42. You work for a large pharmaceutical company whose data science team wants to use unsupervised learning machine algorithms to help discover new drugs. What is an advantage to this approach?

- [ ] You will be able to prioritize different classes of drugs, such as antibiotics.
- [ ] You can create a training set of drugs you would like to discover.
- [x] The algorithms will cluster together drugs that have similar traits.
- [ ] Human experts can create classes of drugs to help guide discovery.

**Explanation**: This one is similar to an example talked about in the Stanford Machine Learning course.
[Source:](https://www.coursera.org/learn/machine-learning/home/welcome)

#### Q43. In 2015, Google created a machine learning system that could beat a human in the game of Go. This extremely complex game is thought to have more gameplay possibilities than there are atoms of the universe. The first version of the system won by observing hundreds of thousands of hours of human gameplay; the second version learned how to play by getting rewards while playing against itself. How would you describe this transition to different machine learning approaches?

- [x] The system went from supervised learning to reinforcement learning.
- [ ] The system evolved from supervised learning to unsupervised learning.
- [ ] The system evolved from unsupervised learnin9 to supervised learning.
- [ ] The system evolved from reinforcement learning to unsupervised learning.

#### Q44. The security company you work for is thinking about adding machine learning algorithms to their computer network threat detection appliance. What is one advantage of using machine learning?

- [x] It could better protect against undiscovered threats.
- [ ] It would very likely lower the hardware requirements.
- [ ] It would substantially shorten your development time.
- [ ] It would increase the speed of the appliance.

#### QTraining1. You work for a hospital that is tracking the community spread of a virus. The hospital created a smartwatch app that uploads body temperature data from hundreds of thousands of participants. What is best technique to analyze the data?

- [ ] Use reinforcement learning to reward the system when a new person participates
- [ ] Unsupervised machine learning to cluster together people based on patterns the machine discovers
- [ ] Supervised machine learning to sort people by demographic data
- [x] supervised ml to classify people by body temperature

#### QTraining2. Man of the advances in ml have come from improved

- [ ] statistics
- [x] structured data
- [ ] availability
- [ ] algorithms

#### Q45. What is the diagram a good example of ?

![Machine Learning Q45](images/machine-learning_Q45.jpg)

- [ ] unsupervised learning
- [ ] complex cluster
- [ ] multiclass classification
- [x] k-nearest neighbour

#### Q46. The supervisor asks to create a ml system that will help your hr dep. classify job applicants into well-defined groups.What type of system are more likely to recommend?

- [ ] deep learning artificial neural network that relies on petabytes of data
- [ ] unsupervised ml system that clusters together the best candidates
- [ ] Not recommend ml for this project
- [x] supervised ml system that classifies applicants into existing groups // we do not need to classify best candidates we just need to classify job applicants in to existing categories

#### Q47. Someone of your data science team recommends that you use decision trees, naive Bayes and K-nearest neighbor, all at the same time, on the same training data, and then average the results. What is this an example of?

- [ ] regression analysis
- [ ] unsupervised learning
- [ ] high -variance modeling
- [x] ensemble modeling

#### Q48. Your data science team wants to use ml to better filter out spam messages. The team has gathered a database of 100,000 messages that have been identified as spam or not spam. If you are using supervised ml, what would you call this data set?

-[ ] ml algorithm -[x] training set -[ ] big data test set -[ ] data cluster

#### Q49. You work for a website that enables customers see all images of themselves on the internet by uploading one self-photo. Your data model uses 5 characteristics to match people to their foto: color, eye, gender, eyeglasses and facial hair. Your customers have been complaining that get tens of thousands of fotos without them. What is the problem?

-[ ] Overfitting the model to the data -[ ] Smaller training set needed -[x] Underfitting the model to the data -[ ] larger training set needed

#### Q50. Your supervisor asks you to create a machine learning system that will help your human resources department classify jobs applicants into well defined groups. What type of system are you more likely to recommend?

-[ ] an unsupervised machine learning system that clusters together the best candidates. -[ ] you would not recommend a machine learning system for this type of project. -[ ] a deep learning artificial neural network that relies on petabytes of employment data. -[x] a supervised machine learning system that classifies applicants into existing groups.

#### Q51. You and your data science team have 1 TB of example data. What do you typically do with that data?

- [ ] you use it as your training set.
- [x] You label it big data.
- [ ] You split it into a training set and test set.
- [ ] You use it as your test set.

#### Q52. Your data science team is working on a machine learning product that can act as an artificial opponent in video games. The team is using a machine learning algorithm that focuses on rewards: If the machine does some things well, then it improves the quality of the outcome. How would you describe this type of machine learning algorithm?

- [ ] semi-supervised machine learning
- [ ] supervised machine learning
- [ ] unsupervised machine learning
- [x] reinforcement learning

#### Q53. The model will be trained with data in one single batch is known as ?

- [ ] Batch learning
- [ ] Offline learning
- [x] Both A and B
- [ ] None of the above

#### Q54. Which of the following is NOT supervised learning? ?

- [ ] Decision Tree
- [ ] Linear Regression
- [x] PCA
- [ ] Naive Bayesian

#### Q55. Suppose we would like to perform clustering on spatial data such as the geometrical locations of houses. We wish to produce clusters of many different sizes and shapes. Which of the following methods is the most appropriate? ?

- [ ] Decision Trees
- [ ] K-means clustering
- [x] Density-based clustering
- [ ] Model-based clustering

#### Q59. The error function most suited for gradient descent using logistic regression is

- [ ] The entropy function.
- [ ] The squared error.
- [x] The cross-entropy function.
- [ ] The number of mistakes.

#### Q58. Compared to the variance of the Maximum Likelihood Estimate (MLE), the variance of the Maximum A Posteriori (MAP) estimate is **\_\_\_\_**

- [ ] Higher
- [ ] same
- [x] Lower
- [ ] it could be any of the above

#### Q57. \***\*\_\_\_\*\*** refers to a model that can neither model the training data nor generalize to new data.

- [ ] good fitting
- [ ] overfitting
- [x] underfitting
- [ ] all of the above

#### Q58. How would you describe this type of classification challenge?

![Machine Learning Q58](images/machine-learning_Q58.jpg)

- [x] This is a multiclass classification challenge.
      **Explanation**: Shows data being classified into more than two categories or classes. Thus, this is a multi-class classification challenge.
- [ ] This is a multi-binary classification challenge.
- [ ] This is a binary classification challenge.
- [ ] This is a reinforcement classification challenge.

#### Q59. What does it mean to underfit your data model?

- [ ] There is too little data in your training set.
- [ ] There is too much data in your training set.
- [x] There is not a lot of variance but there is a high bias.
      // Underfitted data models usually have high bias and low variance. Overfitted data models have low bias and high variance.
- [ ] Your model has low bias but high variance.

#### Q60. Asian user complains that your company's facial recognition model does not properly identify their facial expressions. What should you do?

- [ ] Include Asian faces in your test data and retrain your model.
- [ ] Retrain your model with updated hyperparameter values.
- [ ] Retrain your model with smaller batch sizes.
- [x] Include Asian faces in your training data and retrain your model.
      // The answer is self-explanatory: if Asian users are the only group of people making the complaint, then the training data should have more Asian faces.

#### Q61. You work for a website that helps match people up for lunch dates. The website boasts that it uses more than 500 predictors to find customers the perfect date, but many costumers complain that they get very few matches. What is a likely problem with your model?

- [ ] Your training set is too large.
- [ ] You are underfitting the model to the data.
- [x] You are overfitting the model to the data.
      **Explanation**: // This question is very similar to Q49 but involves a polar opposite scenario.
- [ ] Your machine is creating inaccurate clusters.

// I find that answer somewhat vague and unsettled. Small number of matchings does not necessarily implies that the model overfits, especially given 500 (!) independent variables. To me, it sounds more reasonable that the threshold (matching) criterion might be too tight, thus allowing only a small number of matching to occur. So a solution can be either softening the threshold criterion or increasing the number of candidates.

#### Q62. (Mostly) whenever we see kernel visualizations online (or some other reference) we are actually seeing:

- [x] What kernels extract
- [ ] Feature Maps
- [ ] How kernels Look

#### Q62. The activations for class A, B and C before softmax were 10,8 and 3. The different in softmax values for class A and class B would be :

- [x] 76%
- [ ] 88%
- [ ] 12%
- [ ] 0.0008%
      ![image](images/machine-learning_Q62.png)

#### Q63. The new dataset you have just scraped seems to exhibit lots of missing values. What action will help you minimizing that problem?

- [ ] Wise fill-in of controlled random values
- [ ] Replace missing values with averaging across all samples
- [ ] Remove defective samples
- [x] Imputation

#### Q64. Which of the following methods can use either as an unsupervised learning or as a dimensionality reduction technique?

- [ ] SVM
- [x] PCA
- [ ] LDA
- [ ] TSNE

#### Q65. What is the main motivation for using activation functions in ANN?

- [x] Capturing complex non-linear patterns
- [ ] Transforming continuous values into "ON" (1) or "OFF" (0) values
- [ ] Help avoiding the vanishing/exploding gradient problem
- [ ] Their ability to activate each neurons individually.

#### Q66. Which loss function would fit best in a categorical (discrete) supervised learning ?

- [ ] kullback-leibler (KL) loss
- [x] Binary Crossentropy
- [ ] Mean Squared Error (MSE)
- [ ] Any L2 loss

#### Q67. What is the correct option?

![image](images/machine-learning_Q67.png)
| no. | Red | Blue | Green |
| --- | --- | --- | --- |
| **1.** | Validation error | Training error | Test error |
| **2.** | Training error | Test error | Validation error |
| **3.** | Optimal error | Validation error | Test error |
| **4.** | Validation error | Training error | Optimal error |

- [ ] 1
- [ ] 2
- [ ] 3
- [x] 4

#### Q68. You create a decision tree to show whether someone decides to go to the beach. There are three factors in this decision: rainy, overcast, and sunny. What are these three factors called?

- [ ] tree nodes
- [x] predictors // these nodes decide whether the someone decides to go to beach or not, for example if its rainy people will mostly refrain from going to beach
- [ ] root nodes
- [ ] deciders

#### Q69. You need to quickly label thousands of images to train a model. What should you do?

- [ ] Set up a cluster of machines to label the images
- [ ] Create a subset of the images and label then yourself
- [x] Use naive Bayes to automatically generate labels.
- [ ] Hire people to manually label the images

#### Q70. The fit line and data in the figure exhibits which pattern?

![image](images/machine-learning_Q70.png)

- [ ] low bias, high variance
- [ ] high bias, low variance
- [ ] high bias, high variance
- [x] low bias, low variance // since the data is accurately classified and is neither overfitting or underfitting the dataset
