﻿### Microsoft Power BI

#### Q1. A dataset that includes \_ can be used to create a map visualization. (Select all that apply.)

    A. house numbers, street names
    B. geospatial data
    C. city names, country names
    D. longitude, latitude

 - [x] A, B, C, D
 - [ ] A, C, D
 - [ ] B, C, D
 - [ ] D

#### Q2. How do you create a chart visual in Power Bl Desktop Report view? (Select all that apply.)

    A. Click New Visual on the Home tab.
    B. Select a chart visual in the Visualizations pane.
    C. Click New Visual on the Data Tools tab.
    D. Select a field that contains values.

 - [ ] A, B, or D
 - [ ] B or D
 - [ ] B orC
 - [x] A or B

#### Q3. What daily sales number does this DAX measure formula calculate? 
`CALCULATE(SUM([Sales]) ,DATESHTD([Date] ))`
 - [ ] running total sales in each month that starts over each month
 - [ ] total sales for the entire month
 - [x] running total in entire year for the entire month
 - [ ] rolling average over 12 months of sales

#### Q4. You are creating a report in Power Bl Desktop and want to restrict the data to records where Country="Canada". To accomplish this, what do you need to create?
 - [x] a directive
 - [ ] a custom column
 - [ ] an indexed column
 - [ ] a parameter

#### Q5. What is the primary benefit of using visualizations such as line charts, bar charts, and column charts?
 - [ ] They are easier to create than other visualizations.
 - [x] They require fewer resources than more complex visualizations.
 - [ ] They are also used in Excel, so they feel familiar to users.
 - [ ] They are free to use.

#### Q6. In Power Bl service, deleted pages are available after deletion until
 - [ ] midnight of the day on which they are deleted
 - [ ] the next billing cycle
 - [ ] you empty the Recycle Bin
 - [x] the report has been saved

#### Q7. You need to add a required color to a bar chart. How can you add an exact color value to an existing bar chart?
 - [x] Click the color in the visual (e.g., the bars) and right-click to select the color.
 - [ ] You cannot select custom colors in a bar chart or related visual.
 - [ ] Select the value closest to this color from the color formatting options.
 - [ ] Enter the hex value into the color formatting options.

#### Q8. The Excel function IF is nearly the same as which DAX function?
 - [ ] SWITCH
 - [ ] IF
 - [x] IFX
 - [ ] IFS

#### Q9. Consider the Power Bl extract, transform, and load process (ETL). During this process, data is read and then
 - [x] stored in S#### QL Server
 - [ ] written to an OLAP cube
 - [ ] assigned a data type
 - [ ] sorted by primary key

#### Q10. Power Bl's Publish to Web option allows you to embed visualizations within \_. (Select all that apply.)

    A. blog posts
    B. email messages
    C. web sites
    D. text messages

 - [ ] A,C
 - [ ] C
 - [ ] A, B, C
 - [x] A, B, C, D

#### Q11. What can you do within the Power Bl Desktop #### Query Settings pane? (Select all that apply.)

    A. Rename a query step.
    B. Delete a query step.
    C. Delete from one query step to the end.
    D. Reorder the steps.

 - [ ] B, C, D
 - [x] A, B, C, D [proof link](https://docs.microsoft.com/en-us/power-bi/transform-model/desktop-query-overview)
 - [ ] A, B, D
 - [ ] A, B, C

#### Q12. After you enter text in the #### Q&A box or O&A visual, Power Bl will `\_` your data to create a list of appropriate visualizations.
 - [ ] filter and group
 - [ ] sort and filter
 - [ ] sort, filter, and group
 - [ ] sort and group

#### Q13. You just deleted a dashboard in the Power Bl service and want to get it back. What should you do?
 - [x] Press Ctrl+Z. 
    [proof link1](https://docs.microsoft.com/en-us/power-bi/visuals/service-tips-and-tricks-for-color-formatting)
    [link2](https://www.edureka.co/community/26060/how-do-i-undo-something-in-power-bi)
 - [ ] Select Undo from the toolbar.
 - [ ] You cannot undo the deletion of a dashboard.
 - [ ] Recover it from the Recycle Bin.

#### Q14. You have a sales data source and want to relate the tables. The table that contains sales transactions is a _____ table that contains product information is a \_ table .
 - [ ] dimension; fact
 - [ ] lookup; data
 - [ ] data; lookup
 - [ ] data; supporting

#### Q15. When you are creating a formula in the Power Query Editor, what does IntelliSense provide a list of? (Select all that apply.)

    A. columns
    B. tables
    C. functions
    D. data sources

 - [ ] B,C
 - [ ] A, C, D
 - [ ] C,D
 - [ ] A, B, C

#### Q16. You want to delete a dataset but the Power Bl service will not let you. What is the most likely cause?
 - [ ] A tile on your dashboard contains data from that dataset.
 - [x] The dataset is already being used in a published app.
 - [ ] A report contains data from that dataset.
 - [ ] The dataset is in your workspace.

#### Q17. One of your data columns includes the city, state, and postal code line of a mailing address. You need to separate the fields so you can access the geospatial elements for a map visualization. What transformation should you apply?
 - [ ] Replace values
 - [ ] Split column
 - [ ] Modify data type
 - [ ] Best fit geospatial

#### Q18. Formatting options within a visualization depend on what?
 - [x] the visualization you are formatting 
   [proof link](https://docs.microsoft.com/en-us/power-bi/visuals/service-getting-started-with-color-formatting-and-axis-properties)
 - [ ] the editor you use
 - [ ] the visualization group
 - [ ] your permissions

#### Q19. What tool can you use in Power Bl Desktop to reduce data?
 - [ ] report editor
 - [ ] Power Query Editor
 - [ ] dashboard
 - [x] data modeler

#### Q20. What is NOT a valid data connection type for Power Bl Desktop?
 - [ ] Azure data
 - [ ] file data
 - [x] relationships data
 - [ ] database data

#### Q21. Which data type can be uploaded directly to powerbi.com?
 - [ ] Excel files
 - [ ] comma-separated value (CSV) files
 - [ ] Power Bl Desktop files
 - [x] all of these answers

#### Q22. What does Power Bl Premium provide?
 - [ ] Power Bl Report Server
 - [ ] report sharing without a per-user licens
 - [x] all of these answers
 - [ ] dedicated capacity for your company

#### Q23. You have a report in Power Bl service and want to save the state of a report page for easy access. What feature helps you do this?
 - [x] views
 - [ ] filters
 - [ ] bookmarks
 - [ ] slicers

#### Q24. What daily sales number does this DAX measure formula calculate?
`CALCULATE(SUM([Sales]) ,DATESHTD([Date] ))`
 - [ ] running total sales in each month that starts over each month
 - [ ] total sales for the entire month
 - [ ] running total in entire year for the entire month
 - [ ] rolling average over 12 months of sales

#### Q25.  What should you do to increase the readability of a report?
 - [ ] all of these answers
 - [ ] Remove unnecessary field labels.
 - [ ] Select the most appropriate visualization.
 - [ ] Use borders.

#### Q26. Which feature in the Power BI service is most useful when you need to create pages that present the same visualizations for different territories, salespeople, or teams?
 - [ ] landscape mode
 - [ ] none of these answers
 - [ ] Shrink to Fit
 - [ ] templates 

