## Microsoft Word

#### Q1. Which feature allows you to copy attributes of selected text and apply them to another selection?
- [ ] Merge Formatting command
- [ ] Copy and Paste Styles command
- [ ] Copy and Paste Attributes command
- [x] Format Painter tool

#### Q2. To protect a document from accidental changes, which option should you select from the Protect Document (Windows) or Protect (Mac) menu?
- [ ] Mark as Final.
- [ ] Add a Digital Signature.
- [ ] Encrypt with Password.
- [x] Always Open Read-Only.

#### Q3. You are finalizing a two-page memo. Rather than having Word decide where page 1 ends, you want the next paragraph to begin on the top of page 2. How do you achieve this?
- [ ] Change the bottom margin to your current location.
- [x] Insert a page break.
- [ ] Press Shift + Enter (Shift + Return).
- [ ] Insert a column break.

#### Q4. How do you insert the content of an existing Word document into your current Word document?
- [ ] Click Layout > Text > Text from File.
- [ ] Click Insert > Text > Building Blocks Organizer.
- [x] Click Insert > Text > Text from File.
- [ ] Click Insert > Media.

#### Q5. You want to set a wider inside margin to accommodate binding a document where pages are printed in both sides. Which option should you choose in the Page Setup dialog box.
- [ ] Book Fold.
- [ ] Different Odd & Even Pages.
- [x] Mirror Margins.
- [ ] Landscape.
```
Different Odd & Even Pages. <-- Should not this one instead?
Layout -> Page Setup -> Pages -> Multiple Pages = "Mirror Margins" or "Book Fold"
Both switch the margin options from left/right to inside/outside. But only one "Mirror Margins" is correct for double-sided pages. "Book Fold" includes folding.
```

#### Q6. Which feature lets you place a ghosted logo or text behind the regular text on your document?
- [ ] Background.
- [x] Watermark.
- [ ] Imagemark.
- [ ] Overlay.

#### Q7. Where do you select the paper size for a document?
- [ ] Design > Size.
- [ ] File > Page Setup.
- [x] Layout > Size.
- [ ] Layout > Margins.

#### Q8. Which option lets you mark your favourite templates for quick reuse in the future?
- [ ] Drag to Home tab.
- [ ] Add to chooser.
- [x] Pin to list.
- [ ] Mark as favourite.

#### Q9. If you want to add a caption to a table, where should you look?
- [ ] Insert tab.
- [ ] Design tab.
- [x] References tab.
- [ ] Layout tab.

#### Q10. How can you change the appearance of an entire table in a single step?
- [x] Apply a table style.
- [ ] Apply a graphic style.
- [ ] Right-click a table and choose a new style.
- [ ] Apply a cell style.

#### Q11. Which option does the Find and Replace feature NOT support?
- [ ] Whole Word Only.
- [ ] Replace All.
- [x] Check Spelling.
- [ ] Match Case.

#### Q12. Which statement best describes how a bookmark is used in a Word document?
- [ ] A bookmark is a hyperlink where the label is automatically generated.
- [x] A bookmark works in conjuction with hyperlinks to allow you to quickly jump to a specific location in your document.
- [ ] A bookmark is a link in your document that can goive you quick access to webpages, files and other locations within your document.
- [ ] A bookmark is a color-coded graphic that appears in the navigation pane for easy access to a specific location in your document.

#### Q13. What is NOT an option when inviting a colleague to collaborate on a document?
- [ ] including a personalized message
- [ ] giving the collaborator the option to edit a document
- [ ] setting the collaborator's access to view only
- [x] granting administrator access

#### Q14. You split a document into three sections. What happens if you change the margins in the first section?
- [ ] The document reverts back to a single section with the new margin settings.
- [ ] The new margin settings are applied to all of the sections.
- [ ] The new margin settings are applied to the second and third sections.
- [x] The new margin settings are applied to just the first section.

#### Q15. Which ribbon tab includes commands to add various types of objects or media to your document?
- [x] Insert
- [ ] File
- [ ] Layout
- [ ] Design

#### Q16. What type of page is useful at the front of a large document, to identify the document title, author, and other metadata?
- [x] cover page
- [ ] blank page
- [ ] master page
- [ ] table of contents page

#### Q17. What happens in this SmartArt object when you press the Delete key?
- [x] The boxes resize to maintain the same overall height.
- [ ] The object is deleted and a hole is left behind.
- [ ] The text merges with the second box.
- [ ] The gaps between the boxes close and the boxes remain the same size.

#### Q18. Which command builds an overview of document contents based on applied headings styles?
- [ ] Manage Sources
- [ ] Cross-Reference
- [ ] Insert Index
- [x] Table of Contents

#### Q19. Which statistic does the Word Count feature NOT collect?
- [ ] paragraphs
- [ ] lines
- [x] page breaks
- [ ] characters (no spaces)

#### Q20. What is the default view when you open a document or create a new document?
- [x] Print Layout view
- [ ] Draft view
- [ ] Edit view
- [ ] Web Layout view

#### Q21. You are working on a local copy of a document when Word unexpectedly closes. After you relaunch Word, how can you find the most recently saved version of the document?
- [ ] Click Open > Recent and select Recover Unsaved Documents.
- [ ] Click File > Options > Recover Unsaved Documents.
- [x] Click File > Open > Recent > Documents.
- [ ] Click File > Recent > Recover Unsaved Documents.
```
solutions found in Office2019:
File -> Open -> Recent -> Recover Unsaved Documents
File -> Info -> Manage Document -> Recover Unsaved Documents
Read carefully. It's not about recovering, but only the last recent file!
```

#### Q22. What can you NOT insert into a Word document from the Insert tab?
- [x] a sketch
- [ ] a symbol
- [ ] a 3D model
- [ ] an equation

#### Q23. What Microsoft Word feature lets you capture a portion of your screen to be used as an image in your document?
- [x] Screen Clipping
- [ ] Screen Grab
- [ ] Screen Capture
- [ ] none of these answers

#### Q24. You want to create a shortcut that replaces an acronym that you type with the acronym's full text-for example, replacing `"/mt"` with `"Microsoft Teams"`. What Word feature do you use to create this shortcut?
- [ ] Replace All
- [ ] AutoFormat As You Type
- [x] Find and Replace
- [ ] AutoCorrect Options
```
Home -> Edeting -> Replace -> "Finde and Replace"
File -> Options -> Proofing -> AutoCorrect Options -> Replace text as you type
```

#### Q25. Your document contains two columns of content with a vertical line between the columns, as shown. From where can you delete the line?
![picture](https://cdn.lynda.com/question/5d379809498e21bc9b0800bc/5d379809498e21bc9b0800bc-1563924805745)
- [ ] Insert > Text
- [x] Columns dialog box
- [ ] Insert > Line > Vertical
- [ ] Insert > Line > Remove
```
personal hint:
Layout -> Columns -> More columns -> Line between
```

#### Q26. You crop an image in a document, what happens to the image and the overall document file size?
- [ ] The cropped parts of the image are hidden and the overall file size increases.
- [ ] The cropped parts of the image are removed and the overall file size does not change.
- [x] The cropped parts of the image are hidden and the overall file size does not change.
- [ ] The cropped parts of the image are removed and the overall file size decreases.

#### Q27. When you are typing in a paragraph and reach the end of the line, Word automatically starts a new line for you. What is this feature called?
- [ ] line wrap
- [x] word wrap
- [ ] a new line return
- [ ] a soft return

#### Q28. You want to create an organizational chart. Which SmartArt category should you choose?
- [ ] Pyramid
- [ ] Relationship
- [x] Hierarchy
- [ ] Matrix

#### Q29. When you insert page numbers, which position is NOT an option?
- [ ] page margins
- [x] inset
- [ ] current position
- [ ] bottom of page

#### Q30. How can you quickly move an insertion point to the start of the previous paragraph?
- [x] Ctrl + Up Arrow
- [ ] Ctrl + Page Up
- [ ] Alt + Ctrl + Up Arrow
- [ ] Alt + Ctrl + Page Up

#### Q31. You send a document to two clients for review, and each client returns a separate, edited version of the document. How do you most efficiently review their feedback?
- [ ] Click **Review > Accept**. 
- [ ] Turn on **Track Changes**.
- [x] Click **Review > Compare**.
- [ ] Click **Review > Smart Lookup**.

#### Q32. What is the difference between a footnote and an endnote?
- [ ] Footnotes use Arabic numerals and endnotes use letters.
- [ ] A footnote is placed in the page footer, and an endnote is placed on a blank page at the end of the document.
- [x] A footnote is placed at the bottom of the page, and an endnote is placed at the end of the document.
- [ ] An endnote always appears on the bottom of the same page that it references.

#### Q33. Which formatting option was used to create the effect shown below?
![picture](https://cdn.lynda.com/question/5d379809498e21bc9b0800c4/5d379809498e21bc9b0800c4-1563924833648)
- [ ] Drop Cap
- [x] Subscript
- [ ] Small Caps
- [ ] Superscript

#### Q34. What Word building block uses headings to help users identify the contents of a document?
- [x] table of contents
- [ ] page break
- [ ] cover page
- [ ] index

#### Q35. You have been reviewing a Word document using Track Changes. There are still changes that need to be reviewed, but you cannot see them. Why is this? (Select all that apply.) 
```
A. Display for Review is set to No Markup.
B. Track changes has been turned off.
C. Display for Review is set to Original.
D. Inserts and Deletions and Formatting are turned off in Show Markup.
```
- [ ] A, C, D
- [x] A, B
- [ ] D
- [ ] A, C

#### Q36. You are coordinating the update of your company's 10-chapter operations manual. You begin by saving each chapter as a separate document. What Word feature can you use to manage all of these chapter documents?
- [ ] the Organizer
- [x] master document
- [ ] outline view
- [ ] versioning

#### Q37. Which is a benefit of using heading styles to format a report?
- [ ] You can reformat all headings by changing style sets.
- [ ] You can navigate from heading to heading in the Navigation pane.
- [x] all of these answers
- [ ] You can easily generate a table of contents.

#### Q38. You need to add a trademark symbol to a new product name. How can you accomplish this? (Select two items.) 
```
 A. Type "(TM)".
 B. On the **Insert**  tab, in the **Symbols**  group, select **Symbol** . From the symbols gallery, select the trademark symbol, then click **Insert**.
 C. On the **Insert** Tab, in the **Illustrations**  group, select  **Icons**. From the icons gallery, select the **Signs and Symbols**  category. Then select the trademark symbol and click **Insert**.
 D. Type "(R)".
```
- [ ] B and D
- [x] A and B
- [ ] B and C
- [x] A and D
```
hint:
TM : (Unregistered) trademark symbol
R:    Registered trademark symbol
```

#### Q39. You are reformatting a professional document that you created previously using manual formatting. In your document, first-level headings are formatted with Arial 11 Bold. What is the fastest way to create and apply a Heading 1 style using these properties?
- [ ] In the **Styles**  task pane, click **New Style**  and select **Arial 11 Bold**.
- [ ] Hold the Ctrl key (Windows) or Command key (Mac) and click the **Format Painter**. Then select **New Style**.
- [x] Select one of the first level headings. Right-click **Heading 1**  and update it to match the selection.
- [ ] Select the text, right-click to display the formatting bar, and select **Styles > Copy**.

#### Q40. You are typing text in two columns . When you reach the end of a paragraph in column 1, you want to start the next paragraph in column 1 on the next page. What type of break should you insert at this point?
- [ ] next page section break
- [ ] continiuos section break
- [ ] column break
- [x] page break

### Q41. You want to capture all the content and design elements in your current document, so you can use them as a starting point when creating new documents. To do so, save the current document as _______.
- [x] a template file
- [ ] a PDF
- [ ] an openDocument Text file
- [ ] a Rich Text Format file

### Q42. Which file format best preserves formatting and allows editing when a Word document is transferred to another application?
- [ ] XML Paper Specification (XPS)
- [ ] OpenDocument Text(ODT)
- [x] Rich Text Format (RTF)
- [ ] plain text(TXT)


#### Q43. How can you break a table into two parts?
- [x] Use the Split Table command.
- [ ] Press Shift + Enter (Windows) or Sift + Return (Mac).
- [ ] Use the Section Break command.
- [ ] Use the Split Cells command.
```
Tables Layout tab -> Merge group -> Split Table
```

#### Q44. What can you NOT create from a Word document?
- [ ] a Word macro-enabled document
- [ ] a plan text file
- [x] a multipage website
- [ ] a Word 2003 XML document
```
html files are one sided
```

#### Q45. How can you add a manual line break to a paragraph?
- [ ] Press Enter twice (Windows) or Return twice (Mac).
- [ ] Press Alt + Enter (Windows) or Option + Return (Mac).
- [ ] Press Enter (Windows) or Return (Mac).
- [x] Press Shift + Enter (Windows) or Shift + Return (Mac)

#### Q46. You want to repeat an element (such as the date<9 on all pages of the document. Which options should you choose?
- [x] Insert > Header & Footer
- [ ] Insert > Text
- [ ] Design > Header & Footer
- [ ] View > Header & Footer

#### Q47. A document has been shared with you from your colleague's OneDrive library. They habe given only you editing acces. What can you do with this document?
- [x] Share the document with others.
- [ ] Assume ownership of the document.
- [ ] Remove access from another user.
- [ ] Coauther the document with your colleague.

#### Q48. In the image below, what do the red bar next to the text mean?
 - [ ] none of these answers
 - [ ] Draw tools were used in these areas.
 - [x] Change were made to these areas.
 - [ ] Comments were added to these areas.

#### Q49. What formatting must you use to use both portrait and landscape pages in the same Word document?
 - [ ] templates
 - [ ] pages
 - [ ] columns
 - [x] sections
 
#### Q50. Which option does the Find and Replace feature NOT support?
 - [x] Match Punctuation
 - [ ] Replace All
 - [ ] Match Case
 - [ ] Whole Word Only

#### Q51. What is the name of the text effect that displays a large capital letter at the beginning of the paragraph?
 - [ ] superscript
 - [x] drop cap
 - [ ] subscript
 - [ ] small caps
 
 #### Q52. You need to document a procedure. Which paragraph format is best to help readers follow the sequence of instructions?
 - [ ] line numbers
 - [x] numbered list
 - [ ] columns
 - [ ] bulleted list
 
 #### Q53. How can you adjust which data in a table is used when creating a chart?
 - [ ] Click the Select Data button.
 - [ ] Click the Refresh Data button.
 - [ ] Click the Switch Row/Column button.
 - [ ] Click the Edit Data button.
 
 #### Q54. You want to be able to edit your Word document simultaneously with other Word usere in your organization. Which save location should you select in the Save As dialog box?
 A. OneDrive
 B. SharePoint document library
 C. Google Drive
 D. DropBox
 - [ ] A
 - [ ] A, B, C, D
 - [ ] A, B, C
 - [ ] A or B
