## Search Engine Optimization (SEO)

#### Q1. When developing a backlink strategy, what approach would be most beneficial?
- [x] Guest post the article to as many sites as possible
- [ ] Create an infographics and share it with relevant bloggers
- [ ] Create diverse and unnatural links
- [ ] Distribute links in comment sections of websites

#### Q2. What is a key reason the URL `domain.com/apparel/jackets` is preferable to the URL `domain.com/p=141`?
- [ ] It is longer
- [ ] It is not preferable
- [ ] It uses structured markup
- [x] It is readable to a human

#### Q3. Which HTTP response status code would indicate a page has been moved permanently?
- [ ] 410
- [ ] 302
- [ ] 200
- [x] 301

#### Q4. You notice a website is serving HTML to a Search Engine than to a human user. What is this an example of?
- [ ] Spam injection
- [x] Cloaking
- [ ] Sneaky Redirect
- [ ] Splicing

#### Q5. What would significantly improve Google&#39;s ability to a non-YouTube video in its Search Results?
- [ ] Provide a 150 x 80 pixel thumbnail image
- [x] Add Schema.org VideoObject
- [ ] Convert .mp4 videos to .mov
- [ ] Embed video objects with JavaScript conditionals

#### Q6. Google primarily determines indexing and ranking by crawling which version of a page?
- [x] Responsive version
- [ ] Submitted version
- [ ] Mobile version
- [ ] Desktop version

#### Q7. You want to identify which US state has the most search interest for a particular keyword. What tool would help you determine this?
- [ ] Google Analytics
- [ ] Google Keyword Planner
- [ ] Google Search Console
- [x] Google Trends

#### Q8. You want to block crawlers from accessing your entire website. What robots.txt entry would you use?
- [ ]
```markdown
User-agent: Allbots
Disallow: \*
```
- [ ]
```markdown
User-agent: /
Disallow: \*
```
- [ ]
```markdown
User-agent: /
Disallow:
```
- [x]
```markdown
User-agent: \*
Disallow: /
```

#### Q9. Which results is most likely if you use an interstitial pop-up that requires a user to take action before you load the content of the page?
- [ ] Both the pop-up and the content of the page will be indexed
- [x] The pop-up will be indexed instead of the desired body content
- [ ] An interstitial pop-up is treated the same as a soft 404
- [ ] The pop-up will be ignored, and the content of the page will be indexed correctly

#### Q10. You notice a particular product in an e-commerce storefront is no longer indexed despite no technical issues. What is a likely reason for this?
- [x] No title or meta description tags were provided
- [ ] The Keywords is too competitive
- [ ] Robots.txt is configured to allow access
- [ ] The product is out of stock

#### Q11. All bylone dates for articles are suddenly no longer visible on a `website&#39;s` listing within Google Search. Assuming no changes have been made to the site programming or content, what is the most likely cause?
- [ ] The site has been delisted from Google Search
- [ ] A Google News sitemap was not provided within 30 days of setting up a publisher center account
- [ ] The site kept updating the dates to make the content appear fres, without changing
- [x] The articles have aged more than 365 days without any significant updates to the content or the site

#### Q12. Which approach is not advisable to Geo-targeting your website?
- [ ] Using a gTLD with subdomain
- [x] using URL parameters
- [ ] Using a ccTLD
- [ ] Using a gTLD with a subdirectory

#### Q13. You have been asked to help a big e-commerce brand optimize their website for search engines. They currently have thousands of products listed on their website. What is your most appropriate first step?
- [ ] Recommend that they add more products
- [x] WOrd on compressing image files
- [ ] 302 redirect all product pages to URL that contains target keywords
- [ ] 302 redirect all product ages to a URL that contains target keywords
- [ ] Register the business with a Google My Business account.

#### Q14. What Does The Term &quot;Sandbox&quot; Mean In SEO?
- [ ] The Box With Paid Ads That Appear When You Perform A Search.
- [x] This Is Where Sites Are Kept Till They Get Mature Enough To Be Included In The Top Rankings For A Particular Keyword
- [ ] A Special Category Of Sites That Are Listed In Kid-safe Searches
- [ ] The First 10 Search Results For A Particular Keyword.

#### Q15. What Is Anchor Text?
- [ ] It Is The Main Body Of Text On A Particular Web Page
- [ ] It Is The Text Within The Left Or Top Panel Of A Web Page
- [x] It Is The Visible Text That Is Hyper Linked To Another Page
- [ ] It Is The Most Prominent Text On The Page That The Search Engines Use To Assign A Title To The Page

#### Q16. Which Google search query should be used to return only PDF documents that reference Microsoft?
- [ ] Microsoft + .pdf
- [ ] "Microsoft" + "pdf"
- [ ] Microsoft AND "pdf"
- [x] Microsoft filetype:pdf

#### Q17. Which link is not crawlable?
- [ ] `<a href="http://domain.com">`
- [ ] `<a onclick="newwin('domain.com')">`
- [ ] `<a href="http://domain.com" class="blue">`
- [ ] `<a href="../category-2/page">`

#### Q18. Which choice represents the best header structure?
- [ ]
```markdown
H1: How to Bak Bagels
H2: Ingredients
H3: Dry Ingredients
H4: Wet Ingredients
H2: Instructions
H6: Reviews
```
- [ ]
```markdown
H1: How to Bak Bagels
H1: Ingredients
H1: Dry Ingredients
H1: Wet Ingredients
H1: Instructions
H2: Reviews
```
- [ ]
```markdown
H1: How to Bak Bagels
H2: Ingredients
H3: Dry Ingredients
H3: Wet Ingredients
H2: Instructions
H2: Reviews
```
- [x]
```markdown
H1: How to Bak Bagels
H2: Ingredients
H4: Dry Ingredients
H5: Wet Ingredients
H6: Instructions
H1: Reviews
```

#### Q19. You want to block crawlers from accessing your entire website. What `robots.txt` entry would you use?
- [ ]
```markdown
User-agent: \*
Disallow: /
```
- [ ]
```markdown
User-agent: \*
Disallow: /
```
- [ ]
```markdown
User-agent: /
Disallow: \*
```
- [ ]
```markdown
User-agent: Allbots
Disallow: \*
```

#### Q20. All byline dates articles are suddenly no longer visible on a website's listing within Google Search. Assuming no changes have been made to the site programming or content, what is the most likely cause?
- [ ] The site has been delisted from Google Search
- [ ] The site kept updating the date to make the content appear fresh, without changing the content.
- [ ] The articles have aged more than 365 days without any significant updates to the content or the site.
- [ ] A Google New sitemap was not provided within 30 days of setting up a Publisher Center account

#### Q21. What is an example of a Google search result that can be found in position zero?
- [ ] Google Ads result
- [x] featured snippet
- [ ] related searches
- [ ] autocomplete

#### Q22. When creating accessible video content, what should you consider including?
- [x] transcript
- [ ] thumbnail
- [ ] Flash Player
- [ ] event tracking

#### Q23. You are optimizing a website that sells supplies for banking donuts. Which approach is most appropriate to drive more organic traffic?
- [ ] Buy donutbakingsupplies.com and 301 redirect to your website
- [ ] Add the keyword "donut supplies" to every page.
- [ ] Create a new blog with high-quality donut recipes
- [ ] Join a link farm to rapidly build inbounnd links.

#### Q24. Why is it important to be mindful of outbound follow links?
- [ ] There is a limit to how many links you can create.
- [ ] all of these answers
- [ ] Any follow links reduce your PageRank by 1.
- [ ] Your site's reputation is tied to the sites you link to.

#### Q25. Which statement is true about JSON-LD?
- [ ] It has no relation to JSON.
- [ ] It is the only structured data format available.
- [ ] It is considered the most complicated approach to adding structured data.
- [x] It is Google's preferred structured data format.

#### Q26. What is a key reason why duplicate content might cause an issue with ranking?
- [ ] It creates an inability to use canonical URLs, which dramatically reduces crawl effectiveness,
- [ ] It requires using a 302 redirect, which dilutes PageRank.
- [ ] It triggers an immediate manual action penalty, which delists an entire domain until the duplicate content is removed.
- [ ] It makes it difficult for a search engine to determine the original and authoritative content source.

#### Q27. What attribute would you use to describe the content of an image?
- [ ] tabindex
- [ ] longdesc
- [ ] src
- [x] alt

#### Q28. You are researching keywords for a client and creating list for an optimization plan. Which is not a recommended method of creating keyword lists?
- [ ] synonyms and related words
- [ ] queries about benefits, features, problems
- [ ] how-to and question-based queries
- [x] focusing on only high-volume, high-popularity words

#### Q29. You want to get a rough idea of how many searches per month a particular search term gets. Which tool do you use?
- [x] Google Keyword Planner
- [ ] Google Tag Manager
- [ ] Google Search Console
- [ ] Google Suggest

#### Q30. Changing the title tag and/or meta description will have a measurable impact on your \_\_\_\_.
- [ ] RSS
- [ ] CTR
- [ ] PPC
- [ ] LSI
