## SharePoint

#### Q1. Which permission allows a user to create lists and document libraries, edit pages, apply themes?
- [ ] `Edit`
- [ ] `Contribute`
- [x] `Design`
- [ ] `Approve`

#### Q2. What happens when a file is deleted in Sharepoint?
- [ ] `It is permanently deleted`
- [ ] `It appears in the second-stage Recycle Bin`
- [x] `It appears in the Sharepoint Recycle Bin`
- [ ] `It remains on the list, but is marked as deleted`

#### Q3. You are creating a new Sharepoint subsite. From the following image, which template would you select to create a site that features scorecards, dashboards and access to PerformancePoint Services content?
- [ ] `Basic Search Centre`
- [x] `Business Intelligence Centre`
- [ ] `Records Centre`
- [ ] `Enterprise Search Centre`

#### Q4. You have enabled cloud hybrid search in your organisation. What capability does this feature enable?
- [ ] `the ability to search accross any web app`
- [ ] `the ability to search accross multiple site collections`
- [x] `the ability to search both cloud and on-premises SharePoint sites`
- [ ] `the ability to search Sharepoint and OneDrive`

#### Q5. A user wants to place a OneDrive document into Sharepoint. How can the user accomplish this?
- [x] `1. In the OneDrive web app, select the file 2. Select Move to from the ribbon 3. Select the destination site 4. Select the destination folder`
- [ ] `1. In the OneDrive web app, select the file 2. Select Move to from the ribbon 3. Select the destination site`
- [ ] `1. In the OneDrive web app, select the file 2. Select the destination site 3. Select the destination folder 4. Select Move to from the ribbon`
- [ ] `1. In the OneDrive web app, select the file 2. Select the destination site 3. Select the destination folder`

#### Q6. A user wants to know what options are available when versioning is enabled. Which choice is not a versioning option?
- [ ] `Indicate who should see the draft items in this document library`
- [ ] `Require documents to be checked out before they can be edited`
- [x] `Open behaviour for browser-enabled documents is the default`
- [ ] `Require content approval for submitted items`

#### Q7. You are building a workflow between applications in a Sharepoint site. How do you test a workflow functionality?
- [x] `Allow a workflow to manually start`
- [ ] `Create a new task list as a part of the workflow`
- [ ] `Assign security permissions for the workflow`
- [ ] `Allow a workflow to automatically start`

#### Q8. In Sharepoint what unique feature does a Document Set provide?
- [ ] `file templates`
- [x] `folder and file permissions`
- [ ] `versioning`
- [ ] `folder-assigned metadata`

#### Q9. In a Sharepoint online subscription, where is a users identity managed?
- [ ] `Windows Server`
- [ ] `Azure Active Directory`
- [x] `Microsoft 365 admin centre`
- [ ] `Microsoft 365 Security`

#### Q10. You want to use powershell to retrieve a list of users that are members of the Viewers group in a Sharepoint site. Which command do you use?
- [ ] `Get -SPUserSettingsProviderManager -Web 'https://sharepoint.contoso.com' -Group 'Viewers'`
- [ ] `Get -SPUser 'https://sharepoint.contoso.com' -Group 'Viewers'`
- [ ] `Get -SPUserSettingsProvider -Web 'https://sharepoint.contoso.com' -Group 'Viewers'`
- [x] `Get -SPUser -Web 'https://sharepoint.contoso.com' -Group 'Viewers'`

#### Q11. What is the default state of a document checkout in a Sharepoint library?
- [ ] `not confirgured`
- [ ] `optional`
- [x] `required`
- [ ] `disabled`

#### Q12. Which cloud based tool can you use to add form responses to Sharepoint list?
- [ ] `Forms`
- [ ] `InfoPath` DEPRECATED
- [ ] `Delve`
- [x] `Power Automate`

#### Q13. You have created a workflow using the default issue tracking app. Unlike the tasks list, items are not being synchronised to Outlook tasks. Which statement explains the cause and remedy?
- [ ] `The app is not configured properly through list settings and needs to be re-created`
- [ ] `The default issue tracking app does not support Outlook synchronisation and needs to be customised`
- [x] `The SharePoint version is not version 2013 or newer, which is required to support this feature`
- [ ] `The app is not configured properly through list settings and needs to be modified`

#### Q14. You are creating a new calendar list item in a SharePoint site. You want all users of this calendar to use the offline sync feature with the Outlook client. What steps do you include when creating instructions for users?
- [ ] `1. In the ribbon, select the Calendar tab. 2. Select the calendar in Sharepoint. 3. Select Connect to Outlook 4. Confirm the connection to the calendar.`
- [ ] `1. Select the calendar in Sharepoint. 2. Select Connect to Outlook. 3. In the ribbon, select the Calendar tab. 4. Confirm the connection to the calendar.`
- [x] `1. Select the calendar in Sharepoint. 2. In the ribbon, select the Calendar tab 3. Select Connect to Outlook. 4. Confirm the connection to the calendar.`
- [ ] `1. Select the calendar in Sharepoint. 2. In the ribbon, select the Calendar tab. 3. Confirm the connection to the calendar. 4. Select Connect to Outlook.`

#### Q15. When a group-connected site is created in SharePoint who is assigned as the owner?
- [ ] `The top-level site owner`
- [x] `The group owner`
- [ ] `The site creator`
- [ ] `The the SharePoint admin`

#### Q16. Which SharePoint component can use values such as text, choice, currency and lookup?
- [ ] `library`
- [ ] `calendar`
- [ ] `RSS viewer web part`
- [x] `list`

#### Q17. What must you do when syncing a document library to the local computer?
- [ ] `Enable documents to be available when online`
- [ ] `Select Always keep on this device`
- [ ] `Sign in to OnDrive.com`
- [x] `Sign in to OneDrive`

#### Q18. What type of SharePoint object is SharePoint library?
- [ ] `feature`
- [ ] `collection`
- [ ] `application`
- [x] `site`

#### Q19. Which SharePoint feature can you activate for items related to litigation, investigation or audit?
- [ ] `Metadata navigation and Filtering`
- [ ] `Content Organizer`
- [ ] `Following Content`
- [x] `Hold`

#### Q20. When you create a user in Office365 to which SharePoint permissions group is the user automatically added as a member?
- [ ] `Time Site members`
- [ ] `Time Site visitors`
- [x] `Everyone` NOT SURE
- [ ] `Everyone except external users`

#### Q21. You need to customize the navigation for a site to include a link to a new library. Which area do you need to edit?
- [ ] `site template`
- [x] `site permissions`
- [ ] `Quick Launch`
- [ ] `web part`

#### Q22. You have created a workflow using the default issue tracking app. Unlike the tasks list, items are not being synchronised to Outlook tasks. Which statement explains the cause and remedy?
- [ ] `The app is not configured properly through list settings and needs to be re-created`
- [ ] `The default issue tracking app does not support Outlook synchronisation and needs to be customised`
- [x] `The SharePoint version is not version 2013 or newer, which is required to support this feature`
- [ ] `The app is not configured properly through list settings and needs to be modified`

#### Q23. Which statement is true about SharePoint site collections?
- [ ] `A site collection can exist in multile databases, however one content database can hold only one site collection`
- [ ] `A site collection can exist in only one content database and one content database can hold only one site collection`
- [x] `A site collection can exist in only one content database, however one content database can hold multiple site collections`
- [ ] `A site collection can exist in multile databases and one content database can hold multiple site collections`

#### Q24. A user has requested that a group of documents be hidden from a SharePoint site's search capabilities. How do you access this setting?
- [x] `Library settings > Advanced settings`
- [ ] `Site contents > Edit`
- [ ] `Site settings > Result types`
- [ ] `Library setting > Audience targeting settings`

#### Q25. According to a user a SharePoint list is performing slowly and search results are not accurate. How can you assist in improving the list?
- [x] `Change item-level permissions` NOT SURE
- [ ] `Allow management of content types`
- [ ] `Change the list of experience type`
- [ ] `Set automatic index management`

#### Q26. A new user in your organisation needs the most restrictive SharePoint permissions available, with the exception of being able to add, edit and delete lists, view, add, update and delete list items and documents. Which permissions level do you grant the user?
- [ ] `Contribute`
- [ ] `Design`
- [x] `Edit`
- [ ] `Limited`

#### Q27. You would like to manage SharePoint using PowerShell. What step must you complete first?
- [x] `Add-PSSnapin Microsoft.SharePoint.PowerShell`
- [ ] `Get-Command Microsoft.SharePoint.PowerShell`
- [ ] `Add-PSSnapin -Module: "Microsoft.SharePoint.PowerShell"`
- [ ] `Get-Command -Module "Microsoft.SharePoint.PowerShell"`

#### Q28. Which command do you use to view all SharePoint site collection with PowerShell?
- [ ] `Get-SPSite -Limit All | Format-Table -property URL,ContentDatabase`
- [x] `Get-SPSite -Limit All | Format-Table -property URL`
- [ ] `Get-SPWebApplication | Format-Table -property URL,ConnectDatabase`
- [ ] `Get-SPWebApplication | Get-SPSite -Limit All | Format-Table -property URL,ContentDatabase`

#### Q29. Which cloud-based tool can you use to add form response to a SharePoint List?
- [ ] `Forms`
- [ ] `Delve`
- [ ] `InfoPath`
- [x] `Power Automate`
